<?php
//--------------------------------------
abstract class cULEVEL
{
   const super_user = 0;
   const admin = 1;
   const common_user = 2;
   const checker = 3; // ελεγκτής
   const manufacturer = 4; 
}
//--------------------------------------
abstract class cDOCTYPEAFDSS
{
   const doctype=0;
   const arthro=1;
   const parakratisi=2;
}
//--------------------------------------
abstract class cKARTAEAFDSS
{
   const karta_apodixeon=0;
   const document_date=1;
   const kwd_fuel=2;
   const litra_fuel=3;
   const adeia_pratirio=4;
}
//--------------------------------------
abstract class cSEIRAEAFDSS
{
   const seira=0;
   const rel_doc_type=1;
   const rel_doc_number=2;
   const rel_doc_seira=3;
   const rel_s11=4;
   const rel_progressive=5;
}
//--------------------------------------
abstract class cKARTAFHM
{
   const karta_apodixeon=0;
   const afm=1;
   const document_type=2;
   const parakratisi=3;
   const document_number=4;
   const document_seira=5;
   const kwd_fuel=6;
   const litra_fuel=7;
   const adeia_pratirio=8;
}
//--------------------------------------
abstract class cDAILYFHM
{
   const dailyno=0;
   const retcount=1;
   const retvalue=2;
}
//--------------------------------------
function embed_vars($query, $data)
{
   $data2=array();
   
   foreach ($data as $k=>$v) {
      if (is_string($v)) {
         $v2=strtr($v, "'", "/");
         $data2[":$k"] = "'$v2'";
      }
      else if (is_null($v)) {
         $data2[":$k"] = "''";
      }
      else if ($v<0) {
         $data2[":$k"] = "($v)";
      }
      else {
         $data2[":$k"] = $v;
      }
   }
   
   $s2=strtr($query, $data2);
   if (($i=strpos($s2, "WHERE "))!==false) {
      return substr($s2,0,$i).preg_replace("/=?.\x27\x27/", " IS NULL", substr($s2,$i));
   }
   else {
      return $s2;
   }
}
//--------------------------------------
class cTRANSACTION
{
   private $_db;
   private $completed=false;
   
   function __construct(&$db)
   {
      $this->_db = &$db;
      $this->_db->StartTrans();
   }
   
   function __destruct()
   {
      $this->complete();
   }
   
   function complete()
   {
      if (!$this->completed) {
         $this->_db->CompleteTrans();
         $this->completed=true;
      }
   }
}
//--------------------------------------
class cTAXISRET 
{
   public $afm;
   public $eafdss;
   
   function __construct($afmIN)
   {
      $this->afm = $afmIN;
      $this->eafdss = array(); // map< s11, array(FHM_type, s11) >
   }
}
//--------------------------------------
class cX2
{
   public $db;
   public $xmlpath;
   public $USERID = 0;    
   public $ULEVEL = -1; // undef 
   public $COMPANY;
   public $FULLNAME;
   public $EMAIL;
   public $MyfDatatype;
   public $acceptDSignErr = false;
   public $repeatPostAfter = 0; // default value (minutes) -- 0 = never snd
   
   private $docs;
   private $currencies;
   
   // for compatibility reasons:
   public $agentid=0;
   public $reselid=0;  
   function xlabel() {}
   
   function __construct()
   {
      $this->MyfDatatype=array(
         0=>'Πωλήσεις',
         1=>'Επιστροφές πωλήσεων',
         2=>'Αγορές/ Εξοδα',
         3=>'Επιστροφές Αγορών/ Εξόδων',   
         4=>'Λιανικές πωλήσεις',
         5=>'Εξοδα χωρίς τιμολόγιο'
      );
      
      $this->fill_docs();
      $this->fill_currencies();
      
      $this->xmlpath=sys_get_temp_dir();
      $l=strlen($this->xmlpath);
      if ($this->xmlpath[$l-1]!=='/' && $this->xmlpath[$l-1]!=='\\')
         $this->xmlpath .= DIRECTORY_SEPARATOR;
   
      include("esendconn.inc.php");
      make_database_connection($this->db);
      
      if (!empty($_SESSION['USERID'])) 
         $this->read_session();
   }
   
   function DataTypeStr($dtp)
   {
      return (array_key_exists($dtp, $this->MyfDatatype)?$this->MyfDatatype[$dtp]:($dtp.'#'));
   }
   
   function get_docs_array($prosimo=true)
   {
      $ar1=array();
      
      foreach ($this->docs as $ar2) {
         $s1=sprintf("#%d %s", $ar2[0], $ar2[1] );
         if ($prosimo) {
            $s1 .= " ($ar2[2])";
         }
         $ar1[ $ar2[0] ] = $s1;
      }
      
      return $ar1;
   } 
   
   function read_session()
   {
      $this->USERID   = (int)@$_SESSION['USERID'];
      $this->ULEVEL   = (int)@$_SESSION['ULEVEL'];
      $this->COMPANY  = (string)@$_SESSION['COMPANY'];
      $this->FULLNAME = (string)@$_SESSION['FULLNAME'];
      $this->EMAIL    = (string)@$_SESSION['EMAIL'];
      
      $this->reselid  = $this->USERID;
   }
   
   function __destruct()
   {
      if ($this->db!==false)
         $this->db->Close();
   }
   
   function in_docs($dcode)
   {
      foreach ($this->docs as $ar1) {
         if ($ar1[0]==$dcode) {
            return $ar1[2]; // d/c code
         }
      }
      // not found:
      return false;
   }
   
   function doc_name($dcode)
   {
      foreach ($this->docs as $ar1) {
         if ($ar1[0]==$dcode) {
            return $ar1[1]; // d/c code
         }
      }
      // not found:
      return '';
   }
   
   function in_currency($cc)
   {
      if ($cc==="0") {
         $cc='EUR';
      }
      
      return array_key_exists($cc, $this->currencies);
   }
   
   function currency_name($cc)
   {
      if ($cc==="0") {
         $cc='EUR';
      }
      
      if (array_key_exists($cc, $this->currencies)) {
         return $this->currencies[$cc];
      }
      else {
         return '';
      }
   }

   function fuel_name($fc)
   {
      static $ar1 = array(
         10 => 'Benzine 95RON',
         11 => 'Benzine 95RON+',
         12 => 'Benzine 100RON',
         13 => 'Benzine L.R.P.',
         20 => 'Diesel',
         21 => 'Diesel premium',
         30 => 'Diesel Heating',
         31 => 'Diesel Heat.premium',
         32 => 'Diesel Light',
         40 => 'LPG',
         50 => 'CNG'
      );

      if (array_key_exists($fc, $ar1)) {
         return $ar1[$fc];
      }
      else {
         return '';
      }
   }
   
   function fill_docs()
   {
      $this->docs=array(
         array(  40, "ΔΕΛΤΙΟ ΠΑΡΑΛΑΒΗΣ",          0 ), // "0"
         array(  54, "ΑΠΟΔΕΙΞΗ ΑΣΦΑΛΙΣΤΡΩΝ",                1 ), // "ΣΥΝ"
         array(  56, "ΑΠΟΔΕΙΞΗ ΕΠΙΣΤΡΟΦΗΣ ΑΣΦΑΛΙΣΤΡΩΝ",    -1 ), // "ΜΕΙΟΝ"
         array(  58, "ΤΙΜΟΛΟΓΙΟ ΑΓΟΡΑΣ (ΑΠΟ ΑΓΡΟΤΕΣ)",     -1 ),
         array(  60, "ΤΙΜΟΛΟΓΙΟ ΑΓΟΡΑΣ (ΑΠΟ ΙΔΙΩΤΕΣ)",     -1 ),
         array(  62, "ΤΙΜΟΛΟΓΙΟ ΑΓΟΡΑΣ (ΑΠΟ ΑΡΝΟΥΜΕΝΟΥΣ)", -1 ),
         array(  63, "ΔΕΛΤΙΟ ΕΠΙΣΤΡΟΦΗΣ",                    0 ),
         array(  65, "ΤΙΤΛΟΣ ΑΠΟΘΗΚΕΥΣΗΣ",                  0 ),
         array( 137, "ΕΙΣΙΤΗΡΙΟ Κ.ΔΙΑΣΚΕΔΑΣΗΣ",     	       1 ),
         array( 138, "ΕΙΣΙΤΗΡΙΟ ΘΕΑΜΑΤΩΝ",        	       1 ),
         array( 139, "ΕΙΣΙΤΗΡΙΟ ΣΥΓΚ.ΜΕΣΩΝ",                1 ),
         array( 145, "ΕΙΣΙΤΗΡΙΟ ΠΛΟΙΩΝ",                    1 ),
         array( 147, "ΕΙΣΙΤΗΡΙΟ ΥΔΡΟΘΕΡΑΠΕΙΑΣ",             1 ),
         array( 158, "ΔΕΛΤΙΟ ΑΠΟΣΤΟΛΗΣ",                    0 ),
         array( 159, "ΣΥΓΚΕΝΤΡΩΤΙΚΟ ΔΕΛΤΙΟ ΑΠΟΣΤΟΛΗΣ",    	 0 ),
         array( 160, "ΔΕΛΤΙΟ ΠΑΡΑΔΟΣΗΣ",      	 0 ),
         array( 161, "ΤΙΜΟΛΟΓΙΟ (Πώληση Αγαθών)",           1 ), //	ΣΥΝ
         array( 162, "ΤΙΜΟΛΟΓΙΟ (Παροχή Υπηρεσιών)",        1 ), // ΣΥΝ
         array( 163, "ΤΙΜΟΛΟΓΙΟ (Επιδοτ. Αποζημ. κ.λ.π.)",  1 ), // ΣΥΝ
         array( 165, "ΤΙΜΟΛΟΓΙΟ",                           1 ), // ΣΥΝ
         array( 168, "ΕΚΚΑΘΑΡΙΣΗ",                         -1 ), // ΜΕΙΟΝ
         array( 169, "ΠΙΣΤΩΤΙΚΟ ΤΙΜΟΛΟΓΙΟ",                -1 ), // ΜΕΙΟΝ
         array( 173, "ΑΠΟΔΕΙΞΗ ΛΙΑΝΙΚΗΣ ΠΩΛΗΣΗΣ",           1 ), // ΣΥΝ
         array( 174, "ΑΠΟΔΕΙΞΗ ΠΑΡΟΧΗΣ ΥΠΗΡΕΣΙΩΝ",          1 ), // ΣΥΝ
         array( 175, "ΠΙΣΤΩΤΙΚΟ ΔΕΛΤΙΟ ΛΙΑΝΙΚΗΣ",                -1 ), // ΜΕΙΟΝ
         array( 176, "ΑΠΟΔΕΙΞΗ ΕΙΣΠΡΑΞΗΣ (Συνδρομών εφημερίδων και περιοδικών)",    1 ), // ΣΥΝ
         array( 177, "ΔΕΛΤΙΟ ΚΙΝΗΣΗΣ ΤΟΥΡΙΣΤΙΚΩΝ ΛΕΩΦΟΡΕΙΩΝ",                       0 ),
         array( 178, "ΑΠΟΔΕΙΞΗ ΑΥΤΟΠΑΡΑΔΟΣΗΣ",                                      1 ), // ΣΥΝ
         array( 179, "ΑΠΟΔΕΙΞΗ ΔΑΠΑΝΗΣ",                                           -1 ), // ΜΕΙΟΝ
         array( 180, "ΦΟΡΤΩΤΙΚΗ",                                                   1 ), // ΣΥΝ
         array( 181, "ΔΕΛΤΙΟ ΕΞΑΓΩΓΗΣ",                                         0 ),
         array( 182, "ΔΙΟΡΘΩΤΙΚΟ ΣΗΜΕΙΩΜΑ",                                        -1 ), //	ΜΕΙΟΝ
         array( 183, "ΑΠΟΔΕΙΞΗ ΜΕΤΑΦΟΡΑΣ",                                          1 ), // ΣΥΝ
         array( 188, "ΔΕΛΤΙΟ ΠΑΡΑΓΓΕΛΙΑΣ",                                          0 ),
         array( 190, "ΑΠΟΔΕΙΞΗ ΠΩΛΗΣΗΣ (Αεροπ.Εισιτηρίων)",                         1 ), // ΣΥΝ
         array( 191, "ΕΚΚΑΘΑΡΙΣΗ (Αεροπορικών εισιτηρίων)",                        -1 ), // ΜΕΙΟΝ
         array( 192, "ΑΠΟΔΕΙΞΗ ΠΑΡΑΔΟΘΕΝΤΩΝ ΕΙΣΙΤΗΡΙΩΝ (Αστικών Συγκοινωνιών)",     1 ), // ΣΥΝ
         array( 193, "ΕΚΚΑΘΑΡΙΣΗ (Εισιτήρια Αστικών Συγκοινωνιών)",                -1 ), // ΜΕΙΟΝ
         array( 194, "ΕΚΚΑΘΑΡΙΣΗ (Εφημερίδων και περιοδικών)",                     -1 ), // ΜΕΙΟΝ
         array( 195, "ΕΚΚΑΘΑΡΙΣΗ (Μεριδίων αμοιβ. Κεφαλαίων)",                     -1 ), // ΜΕΙΟΝ
         array( 196, "ΑΠΟΔΕΙΞΗ ΠΑΡΑΔΟΘΕΙΣΩΝ ΚΑΡΤΩΝ (Στάθμευσης δημοσίων χώρων)",    1 ), //	ΣΥΝ
         array( 197, "ΕΚΚΑΘΑΡΙΣΗ (Καρτών σταθμ. δημ. χωρ.)",                       -1 ), // ΜΕΙΟΝ
         array( 199, "ΕΚΚΑΘΑΡΙΣΗ (Πωλ.Ανθέων μέσω ΙΝΤΕΡΦΛΟΡΑ)",   	               -1 ), // ΜΕΙΟΝ
         array( 200, "ΕΚΚΑΘΑΡΙΣΗ (Εισιτηρίων καλαθοσφ. - ΕΣΑΚ)",   	               -1 ), // ΜΕΙΟΝ
         array( 209, "ΕΚΚΑΘΑΡΙΣΗ (ΚΤΕΛ)",                                          -1 ), // ΜΕΙΟΝ
         array( 210, "ΕΚΚΑΘΑΡΙΣΗ (ΙΜΕ)",                                           -1 ), //	ΜΕΙΟΝ
         array( 211, "ΕΚΚΑΘΑΡΙΣΗ (Ασφαλιστικών επιχειρήσεων)",                     -1 ), // ΜΕΙΟΝ
         array( 212, "ΕΚΚΑΘΑΡΙΣΗ (Κοινοπραξιών πλοίων)",                           -1 ), // ΜΕΙΟΝ
         array( 213, "ΕΚΚΑΘΑΡΙΣΗ (Λοιπές Περιπτώσεις)",                     	      -1 ), // ΜΕΙΟΝ
         array( 215, "ΕΙΔΙΚΟ ΑΚΥΡΩΤΙΚΟ ΣΤΟΙΧΕΙΟ",                                   2 ), // ΠΟΣΑ ΑΝΤΙΘΕΤΑ ΤΟΥ ΠΑΡΑΣΤΑΤΙΚΟΥ ΠΟΥ ΑΚΥΡΩΝΕΤΑΙ
         array( 217, "ΒΙΒΛΙΟ ΣΤΑΘΜΕΥΣΗΣ (οχηματων) - ΑΠΟΔΕΙΞΗ ΠΑΡΟΧΗΣ ΥΠΗΡΕΣΙΩΝ",   1 ), //	ΣΥΝ
         array( 218, "ΒΙΒΛΙΟ ΣΤΑΘΜΕΥΣΗΣ - ΦΥΛΑΞΗΣ ΣΚΑΦΩΝ -ΑΠΟΔΕΙΞΗ ΠΑΡΟΧΗΣ ΥΠΗΡΕΣΙΩΝ",   1 ), // ΣΥΝ
         array( 219, "ΒΙΒΛΙΟ ΕΡΓΩΝ - ΔΕΛΤΙΟ ΑΠΟΣΤΟΛΗΣ",                             0 ),
         array( 221, "ΤΙΜΟΛΟΓΙΟ - ΔΕΛΤΙΟ ΑΠΟΣΤΟΛΗΣ",                                1 ), // ΣΥΝ
         array( 222, "ΤΙΜΟΛΟΓΙΟ (Πώληση Αγαθών) - ΔΕΛΤΙΟ ΑΠΟΣΤΟΛΗΣ",                1 ), // ΣΥΝ
         array( 223, "ΤΙΜΟΛΟΓΙΟ (Παροχης Υπηρεσιων) - ΔΕΛΤΙΟ ΑΠΟΣΤΟΛΗΣ",            1 ), //	ΣΥΝ
         array( 224, "ΤΙΜΟΛΟΓΙΟ (Αγοράς από ιδιώτη) - ΔΕΛΤΙΟ ΑΠΟΣΤΟΛΗΣ",           -1 ), // ΜΕΙΟΝ
         array( 225, "ΤΙΜΟΛΟΓΙΟ (Αγοράς αγροτικών προϊόντων) - ΔΕΛΤΙΟ ΑΠΟΣΤΟΛΗΣ",  -1 ), //	ΜΕΙΟΝ
         array( 226, "ΤΙΜΟΛΟΓΙΟ (Παροχή Υπηρεσιων) - ΤΙΜΟΛΟΓΙΟ (Πώληση Αγαθών)",    1 ), //	ΣΥΝ
         array( 227, "ΤΙΜΟΛΟΓΙΟ(Παροχή Υπηρεσιων)-ΤΙΜΟΛΟΓΙΟ(Πώληση Αγαθών)-ΔΕΛ.ΑΠ.",  1 ), // ΣΥΝ
         array( 228, "ΕΚΚΑΘΑΡΙΣΗ - ΔΕΛΤΙΟ ΑΠΟΣΤΟΛΗΣ",                              -1 ), //	ΜΕΙΟΝ
         array( 229, "ΔΕΛΤΙΟ ΠΟΣΟΤΙΚΗΣ ΠΑΡΑΛΑΒΗΣ - ΠΙΣΤΩΤΙΚΟ ΤΙΜΟΛΟΓΙΟ",           -1 ), //	MEION
         array( 231, "ΑΠΟΔΕΙΞΗ ΛΙΑΝΙΚΗΣ ΠΩΛΗΣΗΣ - ΔΕΛΤΙΟ ΑΠΟΣΤΟΛΗΣ",                1 ), //	ΣΥΝ
         array( 232, "ΑΠΟΔΕΙΞΗ ΠΑΡΟΧΗΣ ΥΠΗΡΕΣΙΩΝ - ΔΕΛΤΙΟ ΑΠΟΣΤΟΛΗΣ",               1 ), //	ΣΥΝ
         array( 233, "ΑΠΟΔΕΙΞΗ ΠΑΡΟΧΗΣ ΥΠΗΡΕΣΙΩΝ - ΑΠΟΔΕΙΞΗ ΛΙΑΝΙΚΗΣ ΠΩΛΗΣΗΣ",      1 ), //	ΣΥΝ
         array( 234, "ΑΠΟΔΕΙΞΗ ΕΠΑΓΓΕΛΜΑΤΙΚΗΣ ΔΑΠΑΝΗΣ - ΔΕΛΤΙΟ ΑΠΟΣΤΟΛΗΣ",         -1 ), // ΜΕΙΟΝ
         array( 235, "ΑΠΟΔΕΙΞΗ ΕΠΙΣΤΡΟΦΗΣ - ΔΕΛΤΙΟ ΑΠΟΣΤΟΛΗΣ",                     -1 ), // ΜΕΙΟΝ
         array( 236, "ΠΙΣΤΩΤΙΚΟ ΤΙΜΟΛΟΓΙΟ - ΔΕΛΤΙΟ ΑΠΟΣΤΟΛΗΣ",                     -1 ), // ΜΕΙΟΝ
         array( 237, "ΦΟΡΤΩΤΙΚΗ - ΤΙΜΟΛΟΓΙΟ (Παροχή Υπηρεσιων)",                    1 ), // ΣΥΝ
         array( 238, "ΒΙΒΛΙΟ ΑΠΟΘΗΚΕΥΣΗΣ - ΤΙΤΛΟΣ ΑΠΟΘΗΚΕΥΣΗΣ",                     0 ),
         array( 239, "ΕΙΣΙΤΗΡΙΟ - ΑΠΟΔΕΙΞΗ ΜΕΤΑΦΟΡΑΣ",                              1 ), //	ΣΥΝ
         array( 240, "ΣΥΓΚΕΝΤΡΩΤΙΚΗ ΦΟΡΤΩΤΙΚΗ",                                     1 ), // ΣΥΝ
         array( 242, "ΒΙΒΛΙΟ ΕΙΣΕΡΧΟΜΕΝΩΝ - ΑΠΟΔΕΙΞΗ ΠΑΡΟΧΗΣ ΥΠΗΡΕΣΙΩΝ",            1 ), //	ΣΥΝ
         array( 245, "ΤΙΜΟΛΟΓΙΟ (Αγοράς Αγροτικών Προϊόντων) - ΕΚΚΑΘΑΡΙΣΗ",        -1 ), //	ΜΕΙΟΝ
         array( 246, "ΑΠΟΔΕΙΞΗ ΚΑΙ ΗΜΕΡΟΛΟΓΙΟ ΜΕΤΑΦΟΡΑΣ",                           1 ), // ΣΥΝ
         array( 247, "ΜΗΤΡΩΟ ΜΑΘΗΤΩΝ - ΑΠΟΔΕΙΞΗ ΠΑΡΟΧΗΣ ΥΠΗΡΕΣΙΩΝ",                 1 ), // ΣΥΝ
         array( 251, "ΑΠΟΔΕΙΞΗ ΑΥΤΟΠΑΡΑΔΟΣΗΣ - ΔΕΛΤΙΟ ΑΠΟΣΤΟΛΗΣ",                   1 ), // ΣΥΝ
         array( 252, "ΑΠΟΔΕΙΞΗ ΠΑΡΟΧΗΣ ΥΠΗΡΕΣΙΩΝ-ΜΙΣΘΩΤΗΡΙΟ ΣΥΜΒΟΛΑΙΟ ΑΥΤΟΚΙΝΗΤΩΝ", 1 ), // ΣΥΝ
         array( 253, "ΔΕΛΤΙΟ ΑΠΟΣΤΟΛΗΣ-ΑΠΟΔ.ΛΙΑΝΙΚΗΣ ΠΩΛΗΣΗΣ-ΑΠΟΔ.ΠΑΡΟΧΗΣ ΥΠΗΡΕΣΙΩN", 1 ), // ΣΥΝ
         array( 254, "ΒΙΒΛΙΟ ΕΠΙΣΚΕΨΗΣ ΑΣΘΕΝΩΝ - ΑΠΟΔΕΙΞΗ ΠΑΡΟΧΗΣ ΥΠΗΡΕΣΙΩΝ",       1 ), // ΣΥΝ
         array( 257, "ΑΠΟΔΕΙΞΗ ΠΑΡΟΧΗΣ ΥΠΗΡΕΣΙΩΝ-ΤΙΜΟΛ(Πώλησης)-ΔΕΛΤΙΟ ΑΠΟΣΤΟΛΗΣ",  1 ), // ΣΥΝ
         array( 258, "ΑΠΟΔΕΙΞΗ ΠΩΛΗΣΗΣ ΕΙΣΙΤΗΡΙΩΝ - ΑΠΟΔΕΙΞΗ ΠΑΡΟΧΗΣ ΥΠΗΡΕΣΙΩΝ",    1 ), // ΣΥΝ
         array( 259, "ΒΙΒΛΙΟ ΕΠΙΣΚΕΨΗΣ ΑΣΘΕΝΩΝ - ΑΠΟΔ.ΠΑΡΟΧΗΣ ΥΠΗΡΕΣΙΩΝ (ιατροί,οδοντ)",   1 ), // ΣΥΝ
         array( 260, "ΒΙΒΛΙΟ ΕΡΓΩΝ-ΤΙΜΟΛΟΓΙΟ - ΔΕΛΤΙΟ ΑΠΟΣΤΟΛΗΣ",                   1 ), // ΣΥΝ
         array( 267, "ΤΙΜΟΛΟΓΙΟ - ΔΕΛΤΙΟ ΑΠΟΣΤΟΛΗΣ - ΣΥΝΟΔΕΥΤΙΚΟ ΔΙΟΙΚΗΤΙΚΟ ΕΓΓΡΑΦΟ", 1 ), // ΣΥΝ
         array( 268, "ΑΠΟΔΕΙΞΗ ΠΑΡΟΧΗΣ ΥΠΗΡΕΣΙΩΝ - ΔΕΛΤΙΟ ΠΟΣΟΤΙΚΗΣ ΠΑΡΑΛΑΒΗΣ",     1 ), // ΣΥΝ
         array( 270, "ΤΙΜΟΛΟΓΙΟ ΑΓΟΡΑΣ",                                            -1 ), // ΜΕΙΟΝ
         array( 272, "ΤΙΜΟΛΟΓΙΟ ΑΓΟΡΑΣ - ΔΕΛΤΙΟ ΑΠΟΣΤΟΛΗΣ",                         -1 ), // ΜΕΙΟΝ
         array( 279, "ΑΠΟΔ ΠΑΡΟΧΗΣ ΥΠΗΡΕΣΙΩΝ - ΔΕΛ ΠΟΣΟΤ ΠAΡΑΛΑΒΗΣ - ΔΕΛ ΑΠΟΣΤΟΛΗΣ", 1 ), // ΣΥΝ
         array( 295, "ΔΕΛΤΙΟ ΠΟΣΟΤΙΚΗΣ ΠΑΡΑΛΑΒΗΣ - ΤΙΜΟΛΟΓΙΟ ΑΓΟΡΑΣ",               -1 ), // ΜΕΙΟΝ
         array( 298, "ΔΕΛΤΙΟ ΠΟΣΟΤΙΚΗΣ ΠΑΡΑΔΟΣΗΣ (ΕΚΜ DVD κ.λ.π.)",                  0 ),
         array( 299, "ΔΕΛΤΙΟ ΠΟΣΟΤΙΚΗΣ ΠΑΡΑΛΑΒΗΣ (ΕΚΜ DVD κ.λ.π.)",                  0 ),
         array( 301, "Δ.ΠΟΣΟΤΙΚΗΣ ΠΑΡΑΛΑΒΗΣ-ΑΠΟΔ. ΠΑΡΟΧΗΣ ΥΠΗΡΕΣΙΩΝ (ΕΚΜ DVD κλπ)",  1 ), // ΣΥΝ
         array( 302, "Δ. ΠΟΣΟΤΙΚΗΣ ΠΑΡΑΔΟΣΗΣ-ΑΠΟΔ. ΠΑΡΟΧΗΣ ΥΠΗΡΕΣΙΩΝ (ΕΚΜ DVD κλπ)", 1 ), // ΣΥΝ
         array( 303, "Δ. ΠΟΣΟΤΙΚΗΣ ΠΑΡΑΔΟΣΗΣ - ΔΕΛΤΙΟ ΑΠΟΣΤΟΛΗΣ (ΕΚΜ DVD κλπ)",      0 ),
         array( 304, "Δ. ΠΟΣΟΤΙΚΗΣ ΠΑΡΑΛΑΒΗΣ - ΔΕΛΤΙΟ ΑΠΟΣΤΟΛΗΣ (ΕΚΜ DVD κλπ)",      0 ),
         array( 306, "(ΕΚΜDVD) Δ.ΑΠΟΣΤΟΛΗΣ-Δ.ΠΟΣΟΤ ΠΑΡΑΛΑΒΗΣ-ΑΠΟΔ ΠΑΡ. ΥΠΗΡΕΣΙΩΝ",   1 ), // ΣΥΝ
         array( 307, "(ΕΚΜDVD) Δ.ΑΠΟΣΤΟΛΗΣ-Δ.ΠΟΣΟΤ ΠΑΡΑΔΟΣΗΣ-ΑΠΟΔ ΠΑΡ. ΥΠΗΡΕΣΙΩΝ",   1 ), // ΣΥΝ
         array( 308, "ΑΠΟΔ. ΠΑΡΟΧΗΣ ΥΠΗΡΕΣΙΩΝ - Β. ΕΙΣΕΡΧΟΜΕΝΩΝ - Β. ΣΤΑΘΜΕΥΣΗΣ",    1 ), // ΣΥΝ
         array( 310, "ΠΑΡΑΔΟΣΗ ΚΤΙΣΜΑΤΩΝ",                                           1 ), // ΣΥΝ
         array( 313, "ΒΙΒΛΙΟ ΠΕΛΑΤΩΝ-ΑΠΟΔΕΙΞΗ ΠΑΡΟΧΗΣ ΥΠΗΡΕΣΙΩΝ",                    1 ), // ΣΥΝ
         array( 316, "ΔΕΛΤΙΟ ΛΙΤΡΟΜΕΤΡΗΣΗΣ",                                             0 ),
         array( 317, "ΣΥΓΚΕΝΤΡΩΤΙΚΟ ΔΕΛΤΙΟ ΕΠΙΣΤΡΟΦΗΣ",                              0 ),
         array( 328, "ΕΙΣΙΤΗΡΙΟ ΕΚΔΗΛΩΣΕΩΝ",                                         1 ), // ΣΥΝ
         array( 329, "ΤΙΜΟΛΟΓΙΟ (Παροχ.Υπηρ.) - ΤΙΜ.(Αγοράς Αγρ.Προϊόντων) - ΔΕΛ. ΑΠΟΣΤ",   3 ), // ΣΥΝ ΦΠΑ  ΣΥΝ ΚΑΘ.ΑΞΙΑ ΠΑΡΟΧΗΣ, ΜΕΙΟΝ ΣΤΗΝ ΑΞΙΑ ΑΓΟΡΑΣ
         array( 500, "ΔΙΑΦΟΡΑ ΒΙΒΛΙΑ", 	 	 	                                      0 ),
         array( 501, "ΛΟΙΠΑ ΣΤΟΙΧΕΙΑ",                                               2 ),
         array( 502, "ΑΝΤΙΤΥΠΟ",		                                               0 ),
         
         array( 750, "Aποδοχή Τιμολογίου Αγοράς",                                   -1 ),
         array( 751, "Aποδοχή Πιστωτικού Τιμολογίου Αγοράς",                         1 ),
         array( 752, "Αποδοχή εξόδου άνευ Τιμολογίου Αγοράς",                       -1 ),
         array( 753, "Παραστατικό ΑΥΤΟΤΙΜΟΛΟΓΗΣ",                                   -1 ),
         
         array( 760, "Aποδοχή Τιμολογίου Αγοράς μη εκπιπτόμενου ΦΠΑ",                            -1 ),
         array( 761, "Aποδοχή Πιστωτικού Τιμολογίου Αγοράς μη εκπιπτόμενου ΦΠΑ",                  1 ),
         array( 762, "Αποδοχή εξόδου άνευ Τιμολογίου Αγοράς μη εκπιπτόμενου ΦΠΑ",                -1 ),
         array( 763, "Παραστατικό ΑΥΤΟΤΙΜΟΛΟΓΗΣ μη εκπιπτόμενου ΦΠΑ",                            -1 ),

         array( -750, "Ακυρωτικό Aποδοχής Τιμολογίου Αγοράς",                        1 ),
         array( -751, "Ακυρωτικό Aποδοχής Πιστωτικού Τιμολογίου Αγοράς",            -1 ),
         array( -752, "Ακυρωτικό Αποδοχής εξόδου άνευ Τιμολογίου Αγοράς",            1 ),
         array( -753, "Ακυρωτικό Παραστατικό ΑΥΤΟΤΙΜΟΛΟΓΗΣ",                         1 ),

         array( -760, "Ακυρωτικό Aποδοχής Τιμολογίου Αγοράς μη εκπιπτόμενου ΦΠΑ",                 1 ),
         array( -761, "Ακυρωτικό Aποδοχής Πιστωτικού Τιμολογίου Αγοράς μη εκπιπτόμενου ΦΠΑ",     -1 ),
         array( -762, "Ακυρωτικό Αποδοχής εξόδου άνευ Τιμολογίου Αγοράς μη εκπιπτόμενου ΦΠΑ",     1 ),
         array( -763, "Ακυρωτικό Παραστατικό ΑΥΤΟΤΙΜΟΛΟΓΗΣ μη εκπιπτόμενου ΦΠΑ",                  1 )
         );
   }
   
   function fill_currencies()
   {
      $this->currencies=array(
         "AED" => "United Arab Emirates Dirham",
         "AFN" => "Afghanistan Afghani",
         "ALL" => "Albania Lek",
         "AMD" => "Armenia Dram",
         "ANG" => "Netherlands Antilles Guilder",
         "AOA" => "Angola Kwanza",
         "ARS" => "Argentina Peso",
         "AUD" => "Australia Dollar",
         "AWG" => "Aruba Guilder",
         "AZN" => "Azerbaijan New Manat",
         "BAM" => "Bosnia and Herzegovina Convertible Marka",
         "BBD" => "Barbados Dollar",
         "BDT" => "Bangladesh Taka",
         "BGN" => "Bulgaria Lev",
         "BHD" => "Bahrain Dinar",
         "BIF" => "Burundi Franc",
         "BMD" => "Bermuda Dollar",
         "BND" => "Brunei Darussalam Dollar",
         "BOB" => "Bolivia Boliviano",
         "BRL" => "Brazil Real",
         "BSD" => "Bahamas Dollar",
         "BTN" => "Bhutan Ngultrum",
         "BWP" => "Botswana Pula",
         "BYR" => "Belarus Ruble",
         "BZD" => "Belize Dollar",
         "CAD" => "Canada Dollar",
         "CDF" => "Congo/Kinshasa Franc",
         "CHF" => "Switzerland Franc",
         "CLP" => "Chile Peso",
         "CNY" => "China Yuan Renminbi",
         "COP" => "Colombia Peso",
         "CRC" => "Costa Rica Colon",
         "CUC" => "Cuba Convertible Peso",
         "CUP" => "Cuba Peso",
         "CVE" => "Cape Verde Escudo",
         "CZK" => "Czech Republic Koruna",
         "DJF" => "Djibouti Franc",
         "DKK" => "Denmark Krone",
         "DOP" => "Dominican Republic Peso",
         "DZD" => "Algeria Dinar",
         "EGP" => "Egypt Pound",
         "ERN" => "Eritrea Nakfa",
         "ETB" => "Ethiopia Birr",
         "EUR" => "Euro Member Countries",
         "FJD" => "Fiji Dollar",
         "FKP" => "Falkland Islands (Malvinas) Pound",
         "GBP" => "United Kingdom Pound",
         "GEL" => "Georgia Lari",
         "GGP" => "Guernsey Pound",
         "GHS" => "Ghana Cedi",
         "GIP" => "Gibraltar Pound",
         "GMD" => "Gambia Dalasi",
         "GNF" => "Guinea Franc",
         "GTQ" => "Guatemala Quetzal",
         "GYD" => "Guyana Dollar",
         "HKD" => "Hong Kong Dollar",
         "HNL" => "Honduras Lempira",
         "HRK" => "Croatia Kuna",
         "HTG" => "Haiti Gourde",
         "HUF" => "Hungary Forint",
         "IDR" => "Indonesia Rupiah",
         "ILS" => "Israel Shekel",
         "IMP" => "Isle of Man Pound",
         "INR" => "India Rupee",
         "IQD" => "Iraq Dinar",
         "IRR" => "Iran Rial",
         "ISK" => "Iceland Krona",
         "JEP" => "Jersey Pound",
         "JMD" => "Jamaica Dollar",
         "JOD" => "Jordan Dinar",
         "JPY" => "Japan Yen",
         "KES" => "Kenya Shilling",
         "KGS" => "Kyrgyzstan Som",
         "KHR" => "Cambodia Riel",
         "KMF" => "Comoros Franc",
         "KPW" => "Korea (North) Won",
         "KRW" => "Korea (South) Won",
         "KWD" => "Kuwait Dinar",
         "KYD" => "Cayman Islands Dollar",
         "KZT" => "Kazakhstan Tenge",
         "LAK" => "Laos Kip",
         "LBP" => "Lebanon Pound",
         "LKR" => "Sri Lanka Rupee",
         "LRD" => "Liberia Dollar",
         "LSL" => "Lesotho Loti",
         "LTL" => "Lithuania Litas",
         "LVL" => "Latvia Lat",
         "LYD" => "Libya Dinar",
         "MAD" => "Morocco Dirham",
         "MDL" => "Moldova Leu",
         "MGA" => "Madagascar Ariary",
         "MKD" => "Macedonia Denar",
         "MMK" => "Myanmar (Burma) Kyat",
         "MNT" => "Mongolia Tughrik",
         "MOP" => "Macau Pataca",
         "MRO" => "Mauritania Ouguiya",
         "MUR" => "Mauritius Rupee",
         "MVR" => "Maldives (Maldive Islands) Rufiyaa",
         "MWK" => "Malawi Kwacha",
         "MXN" => "Mexico Peso",
         "MYR" => "Malaysia Ringgit",
         "MZN" => "Mozambique Metical",
         "NAD" => "Namibia Dollar",
         "NGN" => "Nigeria Naira",
         "NIO" => "Nicaragua Cordoba",
         "NOK" => "Norway Krone",
         "NPR" => "Nepal Rupee",
         "NZD" => "New Zealand Dollar",
         "OMR" => "Oman Rial",
         "PAB" => "Panama Balboa",
         "PEN" => "Peru Nuevo Sol",
         "PGK" => "Papua New Guinea Kina",
         "PHP" => "Philippines Peso",
         "PKR" => "Pakistan Rupee",
         "PLN" => "Poland Zloty",
         "PYG" => "Paraguay Guarani",
         "QAR" => "Qatar Riyal",
         "RON" => "Romania New Leu",
         "RSD" => "Serbia Dinar",
         "RUB" => "Russia Ruble",
         "RWF" => "Rwanda Franc",
         "SAR" => "Saudi Arabia Riyal",
         "SBD" => "Solomon Islands Dollar",
         "SCR" => "Seychelles Rupee",
         "SDG" => "Sudan Pound",
         "SEK" => "Sweden Krona",
         "SGD" => "Singapore Dollar",
         "SHP" => "Saint Helena Pound",
         "SLL" => "Sierra Leone Leone",
         "SOS" => "Somalia Shilling",
         "SPL" => "Seborga Luigino",
         "SRD" => "Suriname Dollar",
         "STD" => "São Tomé and Príncipe Dobra",
         "SVC" => "El Salvador Colon",
         "SYP" => "Syria Pound",
         "SZL" => "Swaziland Lilangeni",
         "THB" => "Thailand Baht",
         "TJS" => "Tajikistan Somoni",
         "TMT" => "Turkmenistan Manat",
         "TND" => "Tunisia Dinar",
         "TOP" => "Tonga Pa'anga",
         "TRY" => "Turkey Lira",
         "TTD" => "Trinidad and Tobago Dollar",
         "TVD" => "Tuvalu Dollar",
         "TWD" => "Taiwan New Dollar",
         "TZS" => "Tanzania Shilling",
         "UAH" => "Ukraine Hryvna",
         "UGX" => "Uganda Shilling",
         "USD" => "United States Dollar",
         "UYU" => "Uruguay Peso",
         "UZS" => "Uzbekistan Som",
         "VEF" => "Venezuela Bolivar",
         "VND" => "Viet Nam Dong",
         "VUV" => "Vanuatu Vatu",
         "WST" => "Samoa Tala",
         "XAF" => "Communauté Financière Africaine (BEAC) CFA Franc BEAC",
         "XCD" => "East Caribbean Dollar",
         "XDR" => "International Monetary Fund (IMF) Special Drawing Rights",
         "XOF" => "Communauté Financière Africaine (BCEAO) Franc",
         "XPF" => "Comptoirs Français du Pacifique (CFP) Franc",
         "YER" => "Yemen Rial",
         "ZAR" => "South Africa Rand",
         "ZMW" => "Zambia Kwacha",
         "ZWD" => "Zimbabwe Dollar"
      );
   }
}
//--------------------------------------   
class cCHECKER
{
   public $fname; // 928 always
   public $err=0; // int (some error)
   public $errors; // array of messages
   public $param=0;
   
   public $is_temp=false;
   public $eafdss=false;
   public $eafdssEn8=false;
   public $mtype=0; // 0/1=EAFDSS/FHM
   public $znr=0;
   public $bypassZcheck = false;
   public $vatno=false;
   public $aeskey=false;
   public $indatalog = false; // false or string
   public $daily; // array
   public $progressive; // array
   public $fdatetime; // array
   public $esign; // array
   
   public $eissuer_afm; // array
   public $erecv_afm; // array -- ΑΦΜ ΛΗΠΤΗ
   public $eeafdss11; // array
   public $ekartapod; // array
   public $eznr; // array
   public $edocid; // array
   public $earthro; // array
   public $eparakrat; // array
   public $eseira; // array -- Σειρά Θεώρησης
   public $edocnr; // array -- Αριθμός Παραστατικού
   public $enetvala; // array  
   public $enetvalb; // array
   public $enetvalc; // array
   public $enetvald; // array
   public $enetvale; // array
   public $evatvala; // array
   public $evatvalb; // array
   public $evatvalc; // array
   public $evatvald; // array
   public $egtotal; // array
   public $ecurcode; // array
   public $kwd_fuel; // array
   public $litra_fuel; // array
   public $adeia_pratirio; // array
   public $Hmera; // array
   public $rel_doc_type; // array
   public $rel_doc_number; // array
   public $rel_doc_seira; // array
   public $rel_s11; // array
   public $rel_progressive; // array
   
   private $kwd_fuel_accept; // array
   private $charset;
   private $is_s;
   
   function __construct($_charset, $ui, $_is_s)
   {
      global $x2, $coo;
      $db = &$x2->db;
      
      $this->errors=array();
      $this->charset=$_charset; // 928 or 0
      $this->is_s=$_is_s;
      $this->daily=array();
      $this->progressive=array();
      $this->fdatetime=array();
      $this->esign=array();
      
      $this->eissuer_afm=array();
      $this->erecv_afm=array();
      $this->eeafdss11=array();
      $this->ekartapod=array();
      $this->eznr=array();
      $this->edocid=array();
      $this->earthro=array();
      $this->eparakrat=array();
      $this->eseira=array();
      $this->edocnr=array();
      $this->enetvala=array();  
      $this->enetvalb=array();
      $this->enetvalc=array();
      $this->enetvald=array();
      $this->enetvale=array();
      $this->evatvala=array();
      $this->evatvalb=array();
      $this->evatvalc=array();
      $this->evatvald=array();
      $this->egtotal=array();
      $this->ecurcode=array();
      $this->Hmera=array();
      $this->kwd_fuel=array();
      $this->litra_fuel=array();
      $this->adeia_pratirio=array();
      $this->rel_doc_type=array();
      $this->rel_doc_number=array();
      $this->rel_doc_seira=array();
      $this->rel_s11=array();
      $this->rel_progressive=array();
      $this->retcount=array();
      $this->retvalue=array();
      
      $this->kwd_fuel_accept=array('10', '11', '12', '13', '20', '21', '30', '31', '32', '40', '50');
      
      $fileField = $this->is_s?'S_TXT_FILE':'E_TXT_FILE';
      
      //$this->indatalog = save_data_log(); 
      
      do {
         //
         // Make any tests that do not require database reading first, then the others
         //
         if (!function_exists('openssl_decrypt')) {
            $this->errors[] = "Internal server error (decoding)";
            $this->setError(99);
            break;
         }
         
         if (empty($_FILES[$fileField])) {
            $this->errors[] = "No files submitted";
            $this->setError(1);
            break;
         }
      
         if (($err=$_FILES[$fileField]['error'])>0) {
            $this->errors[] = "Upload error $err";
            $this->setError(1);
            break;
         }
      
         if ($this->charset==928) {
            $this->fname = $_FILES[$fileField]['name'];
         }
         else { // utf-8
            $this->fname = UTF8decode($_FILES[$fileField]['name']);
         }
      
         // POL 1220/2012 (EAFDSS): fname= S11-EEMMHHΩΩΛΛ(10)+ZNR(4)-"_s.txt" = (31)
         // POL 1220/2012 (ΦΗΜ):    fname= S11-ZNR(4)-EEMMHHΩΩΛΛ(10)-"_s.txt" = (31)
         // Virtual EAFDSS: deprecated
         $fLen=31; // normal file length

         $fl=strlen($this->fname); 
         if ($fl>4 && strcasecmp(substr($this->fname, $fl-4), '.enc')==0) { $fl -= 4; } // DEVELOPER
         if ($fl != $fLen) { 
            $this->errors[] = "Λάθος μήκος αρχείου: $fl αντί για $fLen";
            $this->setError(1);
            break;
         }
         
         $filecheker = $this->fname;
         { 
            // DEVELOPER
            $fl=strlen($filecheker); // S11
            if ($fl>4 && strcasecmp(substr($filecheker, $fl-4), '.enc')==0) { 
               $filecheker = substr($filecheker, 0, $fl-4); // reset 
            }
         }
         if ($this->is_s) {
            $baseEnd = '_s';
            $ext = pathinfo($filecheker, PATHINFO_EXTENSION);
            if (strcasecmp($ext, 'TMP')==0) {
               //
               // set 'is_temp'
               //
               $this->is_temp = true; 
               $wantExt = 'tmp';
            }
            else {
               $wantExt = 'txt';
            } 
         }
         else {
            $baseEnd = '_e';
            $wantExt = 'txt';
         }
         $regex = '/^.{3}[0-9]{22}'.$baseEnd.'\\.'.$wantExt.'$/i';  // strict         
         if (!preg_match($regex, $filecheker)) {
            $this->errors[] = "Filename error ('$this->fname' does not follow rules)";
            $this->setError(1);
            break;
         }
         
         $now = time();
         
         $this->eafdss = substr($this->fname, 0, 11); // ansi charset
         $this->eafdssEn8 = gr_to_eng(ToUTF8($this->eafdss)); // Utf-8
         
         $o1=false;
         $query="SELECT USERID, MTYPE, VATNO, AESKEY, LASTPOST, POSTINTERVAL FROM ese_vatno WHERE EAFDSS=:EAFDSS";
         $data=array( 'EAFDSS'=>$this->eafdssEn8 );
         if (($rs=$db->Execute($query,$data))===false) {
            $this->errors[] = __LINE__.$db->ErrorMsg();
            $this->setError(99); // internal server error
            // Can not continue
            break;
         }
         $o1=$rs->FetchNextObject();
         $rs->Close();
         
         if ($o1===false) {
            $ords='';
            for ($i1=0;$i1<11;$i1++) {
               $ords .= ord($this->eafdss{$i1}).' ';
            }
            $this->errors[] = "EAFDSS $this->eafdssEn8 ($ords) not registered";
            if (!$ui) {
               $this->setError(2); // Λάθος 2 (λάθος S/N ΕΑΦΔΣΣ, πχ. δεν είναι καταχωρημένη στην βάση της ΑΑΔΕ)
               //
               // This is critical, can not continue, do not even write in log
               //
               break;
            }
            // else:
            $o1 = (Object)array(
               'MTYPE'=>0, 
               'VATNO'=>'000000000', 
               'AESKEY'=>'0000000000000000000000000000000000000000000000000000000000000000', 
               'LASTPOST'=>'', 
               'POSTINTERVAL'=>0
               );
         }
         
         $x2->repeatPostAfter = (int)$o1->POSTINTERVAL;
         
         if ($this->is_temp)
         {
            if ($x2->repeatPostAfter <= 0) {
               $this->errors[] = "Πολύ γρήγορη επικοινωνία, δεν επιτρέπεται η αποστολή S.TMP";
               if (!$ui) {
                  $this->setError(7);
                  //
                  // Can not continue, do not update LASTPOST
                  //
                  break;
               }
            }
            else {
               // Compare now time and last post
               if (strlen((string)$o1->LASTPOST)==14) {
                  list($year, $mon, $day, $hour, $minute, $second) = sscanf($o1->LASTPOST, '%04d%02d%02d%02d%02d%02d'); 
                  if (($d1 = @mktime($hour, $minute, $second, $mon, $day, $year))!==false) {
                     $delta = ($now - $d1)/60.0; // minutes 
                     if ($delta < $x2->repeatPostAfter) {
                        $this->errors[] = "Πολύ γρήγορη επικοινωνία (".((int)$delta)." αντί για $x2->repeatPostAfter λεπτά) $o1->LASTPOST";
                        if (!$ui) {
                           $this->setError(7);
                           //
                           // Can not continue, do not update LASTPOST
                           //
                           break;
                        }
                     } 
                  }
               }
            }
         }
         
         // Once we have read an EAFDSS record and not aborted communication, we should update database
         // whether S_TXT or S_TMP
         if (!$ui) {
            $query="UPDATE ese_vatno SET LASTPOST=:LASTPOST WHERE EAFDSS=:EAFDSS";
            $data=array( 'LASTPOST'=>date('YmdHis', $now), 'EAFDSS'=>$this->eafdssEn8 );
            if (!$db->Execute($query,$data)) {
               $this->errors[] = __LINE__.$db->ErrorMsg();
               $this->setError(99); // internal server error
               //
               // Can not continue
               //
               break;
            }
         } 
         
         if (!empty($_SESSION['USERAFM']) && $_SESSION['USERAFM'] !== $o1->VATNO)
         {
            $this->errors[] = "EAFDSS $this->eafdssEn8 does not belong to user (user VAT no.= ".$_SESSION['USERAFM'].")";
            if (!$ui) {
               $this->setError(2);
               //
               // Can not continue
               //
               break;
            } 
         }
               
         if ($o1!==false && strlen($o1->AESKEY)!=64) {
            $this->errors[] = "AES key error (not 64 chars.)";
            $this->setError(99);
            //
            // Unexpected error, can not continue
            //
            break;
         }
               
         $this->mtype = $o1->MTYPE;
         $this->vatno = $o1->VATNO;
         $this->aeskey = $o1->AESKEY;
         
         update_data_log($this->indatalog, 'AESKEY='.$this->aeskey );

         if ($this->is_s && $this->mtype==1) { // S + ΤΑΜΕΙΑΚΗ
            $z4str = substr($this->fname, 11, 4);
         }
         else { // EAFDSS
            $z4str = substr($this->fname, 21, 4);
         }
         $regex = '/^[0-9]{4}$/i';  // strict
         if (!preg_match($regex, $z4str)) {
            $this->errors[] = "Z ($z4str) in filename error";
            $this->setError(1);
            //
            // Critical error, possible attack, can not continue
            //
            break;
         }
         $this->znr = (int)$z4str;
         
         $query = 'SELECT COUNT(*) FROM ese_zbypass WHERE EAFDSS=:EAFDSS AND ZNR=:ZNR';
         $data = array('EAFDSS'=>$this->eafdssEn8, 'ZNR'=>$this->znr);
         if (($rs=$db->Execute($query, $data))===false) {
            $this->errors[] = __LINE__.$db->ErrorMsg();
            $this->setError(99); // internal server error
            //
            // Can not continue
            //
            break;
         }
         $row = $rs->FetchRow();
         $rs->Close();
         if ($row[0]>0) { $this->bypassZcheck = true; }

         $deltaZ = $coo->test ? 3*365*24*3600 : 24*3600;
         
         $yy = ($this->is_s && $this->mtype==1) ? substr($this->fname,15,2) : substr($this->fname,11,2);
         if ($yy < 12 || $yy > date('y', $now + $deltaZ) ) { // not before 2012, not after this year + 3 more years
            $this->errors[] = "Year ($yy) in filename error";
            $this->setError(1);
            //
            // Critical error, possible attack, can not continue
            //
            break;
         } 
      
         $mm = ($this->is_s && $this->mtype==1) ? substr($this->fname,17,2) : substr($this->fname,13,2);
         if ($mm<1 || $mm>12) {
            $this->errors[] = "Month ($mm) in filename error";
            $this->setError(1);
            //
            // Critical error, possible attack, can not continue
            //
            break;
         }
      
         $dd = ($this->is_s && $this->mtype==1) ? substr($this->fname,19,2) : substr($this->fname,15,2);
         if ($dd<1 || $dd>31) {
            $this->errors[] = "Day ($dd) in filename error";
            $this->setError(1);
            //
            // Critical error, possible attack, can not continue
            //
            break;
         }
         
         $t1 = @mktime(0,0,0,$mm,$dd,$yy+2000); // based on filename (just recheck for validity)
         $ymd = ($this->is_s && $this->mtype==1) ? substr($this->fname,15,6) : substr($this->fname,11,6);
         if ($t1===false || date('ymd',$t1)!==$ymd || $ymd>date('ymd', $now + $deltaZ)) { // not after today
            $this->errors[] =  "Date ($ymd) in filename error";
            $this->setError(1);
            //
            // Critical error, possible attack, can not continue
            //
            break;
         }
      
         if ($this->is_s) { // S
            if ($this->mtype==0) { // EAFDSS
               $hh=(int)substr($this->fname, 17, 2);
               $mm=(int)substr($this->fname, 19, 2);
            }
            else { // FHM
               $hh=(int)substr($this->fname, 21, 2);
               $mm=(int)substr($this->fname, 23, 2);
            }
            
            if ($hh>23 || $mm>59) {
               $this->errors[] =  "Time ($hh$mm) in filename error";
               $this->setError(1);
               //
               // Critical error, possible attack, can not continue
               //
               break;
            }
         }
         
      } while (false);
   }
   
   function setError($x)
   {
      $this->err=$x;
   }
   
   function text_log()
   {
      global $coo;
      
      if (!$coo->test)
         return;
         
      $now = time();
      $logfile = 'c:\\tmp\\taxis_err_'.date('Ymd').'.log';

      if (empty($logfile))
         return;

      $nowStr = date('Y-m-d H:i:s', $now);
      $sout = '';
      foreach($this->errors as $err1) {
         $sout .= $nowStr.' '.$err1."\n";
      }
      
      file_put_contents($logfile, $sout, FILE_APPEND | LOCK_EX);
   }
   
   function checkLine($j, $etxt) // $j = 1,2,3,...
   {
      if ($this->mtype==0) { // EAFDSS
         $this->check_EAFDSS_Line($j, $etxt);
      }
      else { // TAMEIAKH
         $this->check_FHM_Line($j, $etxt);
      }
      
      // more checks:
      $n=count($this->fdatetime);
      $Hmera = substr($this->fdatetime[$n-1], 0, 8); // default
      if ($this->mtype==0) { // EAFDSS
         if (empty($this->Hmera[$n-1])) { // Ημερομηνία παραστατικού
            $this->Hmera[$n-1] = $Hmera;
         }
         // else o.k.
      }
      else { // FHM
         $this->Hmera[] = $Hmera;
      }
   }
   
   private function check_EAFDSS_Line($j, $etxt) // $j = 1,2,3,...
   {
      global $x2;
      static $OfFields=23;
      
      $ar1=explode(';', $etxt);
      if (($nf=count($ar1))!=$OfFields) {
         $this->errors[] = "Line $j: E sign not o.k. because we found $nf fields instead of $OfFields";
      }
      // normalize:
      while ($nf>$OfFields) {
         array_pop($ar1);
         $nf--;
      }
      while ($nf<$OfFields) {
         $ar1[]='';
         $nf++;
      }
      
      // Index 0: (1ο πεδίο) ΑΦΜ Εκδότη
      if (!preg_match('/^[0-9]{9}$/', $ar1[0])) {
         $this->errors[] = "Line $j: Issuer VAT no. error (not 9 digits)";
      }
      
      // Check if Issuer VAT is registred for this EAFDSS
      if ($this->vatno===false || $ar1[0]!==$this->vatno) {
         $this->errors[] = "Line $j: Issuer VAT no. (".ToUTF8($ar1[0]).") not registred with this EAFDSS";
      }
      $this->eissuer_afm[] = $ar1[0];
      
      // Index 1: (2ο πεδίο) ΑΦΜ Παραλήπτη (CAN NOT REALY check)
      if (strlen($ar1[1])==9 && !CheckAfmAlgorithm($ar1[1])) {                      
         $this->errors[] = "Line $j: Recipient VAT no. (".ToUTF8($ar1[1]).") is not good";
      }
      $this->erecv_afm[] = $ar1[1];

      // Index 2: (3ο πεδίο) S/N ΕΑΦΔΣΣ
      if ($ar1[2]!==$this->eafdss) {      
         $this->errors[] = "Line $j: EAFDSS serial field (".ToUTF8($ar1[2])." different from TXT filename (".ToUTF8($this->eafdss).")";
      }
      $this->eeafdss11[] = $ar1[2];
      
      // Index 3: (4ο πεδίο) Αριθμός Κάρτας Αποδείξεων Πελάτη
      $arF=$this->parse_karta_EAFDSS($ar1[3]);
      
      // checks
      $i = cKARTAEAFDSS::karta_apodixeon;
      if (isset($arF[$i]) && strlen($arF[$i])>169) {
         $this->errors[] = "Line $j: Field 'Customer card number' error";
      }
      $this->ekartapod[] = $ar1[3]; // save the whole field

      $i = cKARTAEAFDSS::document_date;
      if (!empty($arF[$i])) {
         if (preg_match('/^[0-9]{8}$/', $arF[$i])) {
            $this->Hmera[] = $arF[$i];
         }
         else {
            $this->Hmera[] = '';
            $this->errors[] = "Date of document error";
         }
      }
      else {
         $this->Hmera[] = '';
      }

      $kwd_fuel_set=false;
      $i = cKARTAEAFDSS::kwd_fuel;
      if (isset($arF[$i])) {
         $this->kwd_fuel[] = $arF[$i];
         $kwd_fuel_set=true;
         if (!in_array($arF[$i], $this->kwd_fuel_accept)) {
            $this->errors[] = "Line $j: Field 'Kwdikos fuel' ($arF[$i]) contents error";
         }
      }
      else {
         $this->kwd_fuel[] = '';
      }

      $i = cKARTAEAFDSS::litra_fuel;
      if (isset($arF[$i])) {
         $this->litra_fuel[] = $arF[$i];
         if (!preg_match('/^\d{1,9}(\.?\d{1,3})$/', $arF[$i])) {
            $this->errors[] = "Line $j: Field 'Litra fuel' ($arF[$i]) contents error";
         }
      }
      else {
         $this->litra_fuel[] = '';
         if ($kwd_fuel_set) {
            $this->errors[] = "Line $j: Field 'Litra fuel' empty";
         }
      }
      
      $i = cKARTAEAFDSS::adeia_pratirio;
      if (isset($arF[$i])) {
         $this->adeia_pratirio[] = $arF[$i];
         if (!preg_match('/^[0-9]{1,9}$/', $arF[$i])) {
            $this->errors[] = "Line $j: Field 'Αδεια πρατηρίου' ($arF[$i]) contents error";
         }
      }
      else {
         $this->adeia_pratirio[] = '';
      }

      // Index 4: (5ο πεδίο) Ημερομηνία και Ώρα EAFDSS
      if (strlen($ar1[4])!=12) {
         $this->errors[] = "Line $j: Field 'DateTime' length error";
      }
      else if (substr($ar1[4],0,8) > ('20'.substr($this->fname,11,6))) {
         $this->errors[] = "Line $j: Field 'DateTime' ($ar1[4]) after from TXT filename (".substr($this->fname,11,6).")";
      }
      else if (substr($ar1[4],8,2)>23 || substr($ar1[4],10,2)>59) {
         $this->errors[] = "Line $j: Field 'DateTime' ($ar1[4]) time error";
      }
      $this->fdatetime[] = $ar1[4];
      
      // Index 5: (6ο πεδίο) A/A Ημερήσιων Σημάνσεων
      if (!preg_match('/^[0-9]{1,5}$/', $ar1[5]) || $ar1[5]>9999 || $ar1[5]==0) {
         $this->errors[] = "Line $j: Field 'Daily Count' ($ar1[5]) contents error";
      }
      else if (!$this->is_s && $ar1[5]!=(int)substr($this->fname,21,4)) {
          $this->errors[] = "Line $j: Field 'Daily Count' ($ar1[5]) different from TXT filename (".substr($this->fname,21,4).")";
      }
      else if ($this->is_s && $j>0 && !$this->is_temp) { // S
         $n=count($this->daily);
         $prev = $n==0 ? 0 : $this->daily[$n-1];
         if ($ar1[5]!=($prev+1)) {
            $this->errors[] = "Line $j: Field 'Daily Count' ($ar1[5]) error, incorrect sequence";
         }
      }
      $this->daily[] = $ar1[5];
      
      // Index 6: (7ο πεδίο) A/A Προοδευτικών Σημάνσεων
      if (!preg_match('/^[0-9]{1,8}$/', $ar1[6])) {
         $this->errors[] = "Line $j: Field 'Progressive Count' ($ar1[6]) contents error";
      }
      else if (!$this->is_temp) {
         $n=count($this->progressive);
         if ($n>0 && $ar1[6]!=($this->progressive[$n-1]+1)) {
            $this->errors[] = "Line $j: Field 'Progressive Count' ($ar1[6]) error, incorrect sequence";
         }
      }
      $this->progressive[] = $ar1[6];   
   
      // Index 7: (8ο πεδίο) Αριθμός Ζ
      if (!preg_match('/^[0-9]{1,4}$/', $ar1[7])) {
         $this->errors[] = "Line $j: Field 'Z no.' ($ar1[7]) contents error";
      }
      else if ($this->is_s) { // S
         $z4 = (int)substr($this->fname,21,4); // EAFDSS
         if ($ar1[7]!=$z4) { // EAFDSS
            $this->errors[] = "Line $j: Field 'Z no.' ($ar1[7]) different from TXT filename ($z4)";
         }
      }
      else { // E
         $z4 = (int)substr($this->fname,17,4); 
         if ($ar1[7]!=$z4) {
            $this->errors[] = "Line $j: Field 'Z no.' ($ar1[7]) different from TXT filename ($z4)";
         }
      }
      $this->eznr[] = $ar1[7];
      
      // Index 8: (9ο πεδίο) Είδος Παρ/κού # άρθο μηδενικού ΦΠΑ (καταργήθηκε) $ ποσό παρακράτησης φόρου
      $prosimo=0;
      $arF = $this->parse_doctype_EAFDSS($ar1[8]);
      
      $i = cDOCTYPEAFDSS::doctype;
      if (!isset($arF[$i])) { $arF[$i]=0; }
      if (!preg_match('/^[0-9]{1,4}$/', $arF[$i])) {
         $this->errors[] = "Line $j: Field 'Document code' ($ar1[8]) contents error";
      }
      else { // check if allowed
         if (($prosimo = $x2->in_docs($arF[$i]))===false) {
            $this->errors[] = "Line $j: Field 'Document code' ($ar1[8]) unexpected value";
         }
      }
      $this->edocid[] = $arF[$i];
      
      $i = cDOCTYPEAFDSS::arthro; 
      $this->earthro[] = isset($arF[$i]) ? $arF[$i] : NULL;
      
      // TODO: need also check prosimo
      $i = cDOCTYPEAFDSS::parakratisi;
      if (isset($arF[$i]) && !preg_match('/^-?\d{1,16}\.\d{2}$/', $arF[$i])) {
         $this->errors[] = "Line $j: Field 'Document code (parakratisi)' ($ar1[8]) unexpected value";
      }
      $this->eparakrat[] = isset($arF[$i]) ? $arF[$i] : NULL; 
      
      // Index 9: (10ο πεδίο) Σειρά Θεώρησης
      // Σειρά Παραστατικού, και
      // # κωδικός είδους αρχικού παραστατικού # αριθμός αρχικού παραστατικού # σειρά αρχικού παραστατικού 
      // ή
      // [ Αριθμός μητρώου ΦΗΜ αρχικού παραστατικού ] προοδευτικός α/α σήμανσης αρχικού παραστατικού
      if (strlen($ar1[9])>37) { // was 10
         $this->errors[] = "Line $j: Field 'Document series (complete)' ($ar1[9]) length error";
      }
      
      $arF = $this->parse_seira_EAFDSS($ar1[9]);
      
      // checks
      $i = cSEIRAEAFDSS::seira;
      if (isset($arF[$i]) && strlen($arF[$i])>10) {
         $this->errors[] = "Line $j: Field 'Document series' ($ar1[9]) length error";
      }
      $this->eseira[] = (string)@$arF[$i]; 
      
      $i = cSEIRAEAFDSS::rel_doc_type;
      if (isset($arF[$i]) && !preg_match('/^\d{1,4}$/', $arF[$i])) {
         $this->errors[] = "Line $j: Field 'Relative document type' (".ToUTF8($arF[$i]).") error"; 
      }
      $this->rel_doc_type[] = isset($arF[$i]) ? (int)$arF[$i] : NULL;
      
      $i = cSEIRAEAFDSS::rel_doc_number;
      if (isset($arF[$i]) && !preg_match('/^\d{1,10}$/', $arF[$i])) {
         $this->errors[] = "Line $j: Field 'Relative document number' (".ToUTF8($arF[$i]).") error";
      }
      $this->rel_doc_number[] = isset($arF[$i]) ? (int)$arF[$i] : NULL;
      
      $i = cSEIRAEAFDSS::rel_doc_seira;
      if (isset($arF[$i]) && mb_strlen($arF[$i])>10) {
         $this->errors[] = "Line $j: Field 'Relative document seira' (".ToUTF8($arF[$i]).") length error";
      }
      $this->rel_doc_seira[] = isset($arF[$i]) ? $arF[$i] : NULL;
      
      $i = cSEIRAEAFDSS::rel_s11;
      if (isset($arF[$i]) && !preg_match('/.{3}\d{8}$/', $arF[$i])) {
         $this->errors[] = "Line $j: Field 'Relative document FHM type' ($arF[$i]) error";
      }
      $this->rel_s11[] = isset($arF[$i]) ? $arF[$i] : NULL;
      
      $i = cSEIRAEAFDSS::rel_progressive;
      if (isset($arF[$i]) && !preg_match('/\d{1,8}$/', $arF[$i])) {
         $this->errors[] = "Line $j: Field 'Relative document progressive count' ($arF[$i]) error";
      }
      $this->rel_progressive[] = isset($arF[$i]) ? (int)$arF[$i] : NULL;
      
      if ($this->edocid[$j-1] == 215) // $j = 1,2,3,...
      {
         if (!is_null($this->rel_doc_type[$j-1])) // $j = 1,2,3,...
         {
            if ($x2->in_docs($this->rel_doc_type[$j-1])===false)
            {
               $this->errors[] = "Line $j: Field 'Relative document type' (".ToUTF8($ar1[9]).") error";
            }
         }
         else if (is_null($this->rel_s11[$j-1]))
         {
            $this->errors[] = "Line $j: Field 'Seira' (".ToUTF8($ar1[9]).") no relative doc. data";
         }
      }
      
      // Index 10: (11ο πεδίο) Αριθμός Παραστατικού
      if (!preg_match('/^[0-9]{1,10}$/', $ar1[10])) {
         $this->errors[] = "Line $j: Field 'Document number' ($ar1[10]) error (not digits, max 10)";
      }
      $this->edocnr[] = $ar1[10];
      
      // Index 11-20 (πεδία 12-21): Διάφορες αξίες
      $ta=0; 
      for ($i=11;$i<=20;$i++) {
         if (strlen($ar1[$i])>18) {
            $this->errors[] = "Line $j: Field ".($i+1)." (".$ar1[$i].") length error";
         }
      
         $x=(float)($ar1[$i]);
         if (($prosimo == -1 && $x>0) || ($prosimo == 1 && $x<0)) {
            $this->errors[] = "Line $j: Sign error in field ".($i+1)." (".$ar1[$i].")";
         }
         else if ($prosimo == 0 && $x!=0.0) {
            $this->errors[] = "Line $j: Value error in field ".($i+1)." (".$ar1[$i].")";
         }
         
         $negative = ($ar1[$i] < 0);
         
         $ar2=explode('.', $ar1[$i]);
         do {
            if (count($ar2)!=2) {
               $this->errors[] = "Line $j: Syntax error in field ".($i+1)." (".$ar1[$i].")";
               break;   
            }
            
            if ($negative) {
               $ar2[0] = abs($ar2[0]);
            }   

            $s2=sprintf("%d.%02d", $ar2[0], $ar2[1]);
            if ($negative) { $s2 = "-".$s2; }
            if ($s2!==$ar1[$i]) {
               $this->errors[] = "Line $j: Syntax error in field ".($i+1)." (".$ar1[$i].")";
               break;
            }
            
            // Grand total
            if ($i<20) {
               if ($negative) {
                  $ta -= ($ar2[0]*100+$ar2[1]);
               }
               else {
                  $ta += $ar2[0]*100+$ar2[1];
               }
            }
            else { // $i=20 -> final adjustments
               if ($negative) {
                  $t1 = -($ar2[0]*100+$ar2[1]);
               }
               else {
                  $t1 = $ar2[0]*100+$ar2[1];
               }
               
               if ($ta!=$t1) {
                  $this->errors[] = sprintf("Line %d: Total error for field %d/23 (%s instead of %.2f)",
                     $j, $i+1, $ar1[$i], $ta/100); 
                  break;
               }
            }
            
         } while (false);      
      }
      $this->enetvala[] = $ar1[11];  
      $this->enetvalb[] = $ar1[12];
      $this->enetvalc[] = $ar1[13];
      $this->enetvald[] = $ar1[14];
      $this->enetvale[] = $ar1[15];
      $this->evatvala[] = $ar1[16];
      $this->evatvalb[] = $ar1[17];
      $this->evatvalc[] = $ar1[18];
      $this->evatvald[] = $ar1[19];
      $this->egtotal[] = $ar1[20];
      
      // Ελεγχος παρακράτησης (ξανά)
      do {
         if (is_null($this->eparakrat[$j-1])) // nothing to check, $j=1,2,3,...
            break;
         
         /*
         if (strlen($F8['parakra'])>18) {
            $this->errors[] = "Line $j: Field 9 (".$ar1[8].") length error";
         }
         */
      
         $x=(float)$this->eparakrat[$j-1]; // $j=1,2,3,...
         if (($prosimo == -1 && $x>0) || ($prosimo == 1 && $x<0)) {
            $this->errors[] = "Line $j: Sign error in field 9 (".$ar1[8].")";
         }
         else if ($prosimo == 0 && $x!=0.0) {
            $this->errors[] = "Line $j: Value error (not zero) in field 9 (".$ar1[8].")";
         }
         
         $negative = ($this->eparakrat[$j-1] < 0);
         
         $ar2=explode('.', $this->eparakrat[$j-1]);
         do {
            if (count($ar2)!=2) {
               // error already recorded
               break;   
            }
            
            if ($negative) {
               $ar2[0] = abs($ar2[0]);
            }   

            $s2=sprintf("%d.%02d", $ar2[0], $ar2[1]);
            if ($negative) { $s2 = "-".$s2; }
            if ($s2!==$this->eparakrat[$j-1]) {
               $this->errors[] = "Line $j: Syntax error in field 9 (".$ar1[8].")";
               break;
            }
            
            if (abs($x) > abs($ar1[20])) { // μεγαλύτερη αξία από την συνολική αξία
               $this->errors[] = "Line $j: Value error (too big) in field 9 (".$ar1[8].")";
               break;
            }
            
         } while (false);
         
      } while (false);
      
      // Index 21 (22ο πεδίο) Κωδικός νομίσματος
      if (!$x2->in_currency($ar1[21])) {
         $this->errors[] = "Line $j: Field 'Currency code' ($ar1[21]) error";
      }
      $this->ecurcode[] = $ar1[21];
      
      // Signature (23ο πεδίο)
      $fsign = trim(array_pop($ar1)); // in file signature
      
      $s1=implode('', $ar1);
      $s2=sha1($s1); // calculated signature
      if (strcasecmp($s2, $fsign)!=0) {
         $this->errors[] = "Line $j: Signature error (should be ".strtoupper($s2)." instead of $fsign)";
      }
      
      $this->esign[] = $fsign;
   }
   
   private function parse_doctype_EAFDSS($src)
   {
      $ar2=array();
      
      $l=strlen($src);
      $buf='';
      $ftype=cDOCTYPEAFDSS::doctype; // είδος παραστατικού
      for ($i=0;$i<$l;$i++) {
         $c = $src{$i};

         switch ($c)
         {
         case '#':
            if (strlen($buf)>0) {
               $ar2[$ftype] = $buf;
               $buf='';
            }
            $ftype=cDOCTYPEAFDSS::arthro;
            break;
         case '$':
            if (strlen($buf)>0) {
               $ar2[$ftype] = $buf;
               $buf='';
            }
            $ftype=cDOCTYPEAFDSS::parakratisi;
            break;
         default:
            $buf .= $c;
            break;
         }
      }
      
      // process leftover
      if (strlen($buf)>0) {
         $ar2[$ftype] = $buf;
         $buf='';
      }

      return $ar2;
   }

   private function parse_karta_EAFDSS($src)
   {
      $ar2=array();
      
      $l=strlen($src);
      $buf='';
      $ftype=cKARTAEAFDSS::karta_apodixeon; // κάρτα αποδείξεων
      for ($i=0;$i<$l;$i++) {
         $c = $src{$i};

         switch ($c)
         {
         case '#':
            if (strlen($buf)>0) {
               $ar2[$ftype] = $buf;
               $buf='';
            }
            $ftype=cKARTAEAFDSS::document_date;
            break;
         case '?':
            if (strlen($buf)>0) {
               $ar2[$ftype] = $buf;
               $buf='';
            }
            $ftype=cKARTAEAFDSS::kwd_fuel;
            break;
         case '!':
            if (strlen($buf)>0) {
               $ar2[$ftype] = $buf;
               $buf='';
            }
            $ftype=cKARTAEAFDSS::litra_fuel; // ακολουθεί σειρά παραστατικού (#5)
            break;
         case ']':
            if (strlen($buf)>0) {
               $ar2[$ftype] = $buf;
               $buf='';
            }            
            $ftype=cKARTAEAFDSS::adeia_pratirio;
            break;
         default:
            $buf .= $c;
            break;
         }
      }
      
      // process leftover
      if (strlen($buf)>0) {
         $ar2[$ftype] = $buf;
         $buf='';
      }

      return $ar2;
   }
   
   private function parse_seira_EAFDSS($src)
   {
      $ar2=array();
      
      $ar2 = explode('#', $src);
      if (($n=count($ar2))>1)
      {
         if ($n<4) {
            for ($i=0;$i<(4-$n);$i++)
            {
               $ar2[] = '';
            }
         }
         return $ar2;
      } 
      
      $arx = explode('[', strtr($src, ']', '['));
      if (($n=count($arx))>=3)
      {
         $ar2[cSEIRAEAFDSS::seira] = $arx[0];
         $ar2[cSEIRAEAFDSS::rel_s11] = $arx[1];
         $ar2[cSEIRAEAFDSS::rel_progressive] = $arx[2];
         if ($n>=4)
         {
            $ar2[cSEIRAEAFDSS::rel_doc_type] = $arx[3];
         } 
      }

      return $ar2;
   }

   private function parse_karta_FHM($src)
   {
      $ar2=array();
      
      $l=strlen($src);
      $buf='';
      $ftype=cKARTAFHM::karta_apodixeon; // κάρτα αποδείξεων
      for ($i=0;$i<$l;$i++) {
         $c = $src{$i};

         switch ($c)
         {
         case '#':
            if (strlen($buf)>0) {
               $ar2[$ftype] = $buf;
               $buf='';
            }
            $ftype=cKARTAFHM::afm; // ακολουθεί ΑΦΜ (#1)
            break;
         case '@':
            if (strlen($buf)>0) {
               $ar2[$ftype] = $buf;
               $buf='';
            }
            $ftype=cKARTAFHM::document_type; // ακολουθεί είδος παραστατικού (#2)
            break;
         case '$':
            if (strlen($buf)>0) {
               $ar2[$ftype] = $buf;
               $buf='';
            }
            $ftype=cKARTAFHM::parakratisi; // ακολουθεί παρακράτηση (#3)
            break;
         case '%':
            if (strlen($buf)>0) {
               $ar2[$ftype] = $buf;
               $buf='';
            }
            $ftype=cKARTAFHM::document_number; // ακολουθεί αριθμός παραστατικού (#4)
            break;
         case '&':
            if (strlen($buf)>0) {
               $ar2[$ftype] = $buf;
               $buf='';
            }
            $ftype=cKARTAFHM::document_seira; // ακολουθεί σειρά παραστατικού (#5)
            break;
         case '?':
            if (strlen($buf)>0) {
               $ar2[$ftype] = $buf;
               $buf='';
            }
            $ftype=cKARTAFHM::kwd_fuel; 
            break;
         case '!':
            if (strlen($buf)>0) {
               $ar2[$ftype] = $buf;
               $buf='';
            }
            $ftype=cKARTAFHM::litra_fuel; // ακολουθεί σειρά παραστατικού (#5)
            break;
         case ']':
            if (strlen($buf)>0) {
               $ar2[$ftype] = $buf;
               $buf='';
            }
            $ftype=cKARTAFHM::adeia_pratirio;
            break;
         default:
            $buf .= $c;
            break;
         }
      }
      // process leftover
      if (strlen($buf)>0) {
         $ar2[$ftype] = $buf;
         $buf='';
      }

      return $ar2;
   }

   private function parse_daily_no($src)
   {
      $ar2=array();
      $l=strlen($src);
      $buf='';
      $ftype=cDAILYFHM::dailyno; // κάρτα αποδείξεων
      for ($i=0;$i<$l;$i++) {
         $c = $src{$i};

         switch ($c)
         {
         case '#':
            if (strlen($buf)>0) {
               $ar2[$ftype] = $buf;
               $buf='';
            }
            $ftype=cDAILYFHM::retcount;
            break;
         case '$':
            if (strlen($buf)>0) {
               $ar2[$ftype] = $buf;
               $buf='';
            }
            $ftype=cDAILYFHM::retvalue;
            break;
         default:
            $buf .= $c;
            break;
         }
      }
      if (strlen($buf)>0) {
         $ar2[$ftype] = $buf;
         $buf='';
      }

      return $ar2;
   }
   
   private function check_FHM_Line($j, $etxt) // $j = 1,2,3,...
   {
      /*
      1 ΑΦΜ Εκδότη (12)
      2 S/N ΦΗΜ (12)
      3 Αριθμός Κάρτας αποδείξεων Πελάτη (19)
      4 Ημερομηνία και Ώρα (12)
      5 A/A Ημερήσιων Φορολογικών
         Αποδείξεων (5)
      6 A/A Προοδευτικών Φορολογικών
         Αποδείξεων (από έναρξης λειτουργίας) (5)
      7 Αριθμός Ζ (4)
      8 Καθαρό Ποσό Α (13:2)
      9 Καθαρό Ποσό Β (13:2)
      10 Καθαρό Ποσό Γ (13:2)
      11 Καθαρό Ποσό Δ (13:2)
      12 Καθαρό Ποσό Ε (13:2)
      13 ΦΠΑ Α (13:2)
      14 ΦΠΑ Β (13:2)
      15 ΦΠΑ Γ (13:2)
      16 ΦΠΑ Δ (13:2)
      17 Κωδικός νομίσματος (1)
      18 ΠΑΗΨΣ (40)
      */
      global $x2;
      static $OfFields=18;

      $ar1=explode(';', $etxt);
      if (($nf=count($ar1))!=$OfFields) {
         $this->errors[] = "Line $j: E sign not o.k. because we found $nf fields instead of $OfFields";
      }
      // normalize:
      while ($nf>$OfFields) {
         array_pop($ar1);
         $nf--;
      }
      while ($nf<$OfFields) {
         $ar1[]='';
         $nf++;
      }
      
      // 0: (1o πεδίο) ΑΦΜ Εκδότη
      if (!preg_match('/^[0-9]{9}$/', $ar1[0])) {
         $this->errors[] = "Line $j: Issuer VAT no. error (not 9 digits)";
      }
      
      // Check if Issuer VAT is registred for this EAFDSS
      if ($this->vatno===false || $this->vatno!==$ar1[0]) {
         $this->errors[] = "Line $j: Issuer VAT no. (".ToUTF8($ar1[0]).") not registred with this EAFDSS";
      }
      $this->eissuer_afm[] = $ar1[0];
      
      // 1: (2o πεδίο) S/N ΕΑΦΔΣΣ
      if ($ar1[1]!==$this->eafdss) {      
         $this->errors[] = "Line $j: EAFDSS serial field (".ToUTF8($ar1[1])." different from TXT filename (".ToUTF8($this->eafdss).")";
      }
      $this->eeafdss11[] = $ar1[1];
      
      // 2: (3o πεδίο) Αριθμός Κάρτας Αποδείξεων Πελάτη FHM # ΑΦΜ λήπτη @ Είδος παρ.κού $ Παρακράτηση % Α/α παρ/κού & Σειρά
      $arF=$this->parse_karta_FHM($ar1[2]);
      // checks
      $i = cKARTAFHM::karta_apodixeon;
      if (isset($arF[$i]) && strlen($arF[$i])>169) {
         $this->errors[] = "Line $j: Field 'Customer card number' error";
      }
      $this->ekartapod[] = $ar1[2]; // save the whole field

      $i = cKARTAFHM::afm;
      if (isset($arF[$i])) {
         $this->erecv_afm[] = $arF[$i];
      }
      else {
         $this->erecv_afm[] = '';
      }

      $i = cKARTAFHM::document_type;
      if (isset($arF[$i])) {
         $this->edocid[] = (int)$arF[$i];
      }
      else {
         $this->edocid[] = -1;
      }

      $i = cKARTAFHM::parakratisi;
      if (isset($arF[$i])) {
         if (strlen($arF[$i])>13) {
            $this->errors[] = "Line $j: Field ".($i+1)." (".$arF[$i].") length error";
         }

         $ar2=explode('.', $arF[$i]);
         do {
            if (count($ar2)!=2) {
               $this->errors[] = "Line $j: Syntax error in field ".($i+1)." (".$arF[$i].")";
               break;
            }

            $s2=sprintf("%d.%02d", $ar2[0], $ar2[1]);
            if ($s2!==$arF[$i]) {
               $this->errors[] = "Line $j: Syntax error in field ".($i+1)." (".$arF[$i].")";
               break;
            }

         } while (false);

         $this->eparakrat[] = $arF[$i];
      }
      else {
         $this->eparakrat[] = 0.0;
      }

      $i = cKARTAFHM::document_number;
      if (isset($arF[$i])) {
         $this->edocnr[] = (int)$arF[$i];
      }
      else {
         $this->edocnr[] = 0;
      }

      $i = cKARTAFHM::document_seira;
      if (isset($arF[$i])) {
         $this->eseira[] = $arF[$i];
      }
      else {
         $this->eseira[] = '';
      }

      $kwd_fuel_set=false;      
      $i = cKARTAFHM::kwd_fuel;
      if (isset($arF[$i])) {
         $this->kwd_fuel[] = $arF[$i];
         $kwd_fuel_set=true;
         if (!in_array($arF[$i], $this->kwd_fuel_accept)) {
            $this->errors[] = "Line $j: Field 'Kwdikos fuel' ($arF[$i]) contents error";
         } 
      }
      else {
         $this->kwd_fuel[] = '';
      }
      
      $i = cKARTAFHM::litra_fuel;
      if (isset($arF[$i])) {
         $this->litra_fuel[] = $arF[$i];
         if (!preg_match('/^\d{1,9}(\.?\d{1,3})$/', $arF[$i])) {
            $this->errors[] = "Line $j: Field 'Litra fuel' ($arF[$i]) contents error";
         }
      }
      else {
         $this->litra_fuel[] = '';
         if ($kwd_fuel_set) {
            $this->errors[] = "Line $j: Field 'Litra fuel' empty";
         }
      }
      
      $i = cKARTAFHM::adeia_pratirio;
      if (isset($arF[$i])) {
         $this->adeia_pratirio[] = $arF[$i];
         if (!preg_match('/^[0-9]{1,9}$/', $arF[$i])) {
            $this->errors[] = "Line $j: Field 'Αδεια πρατηρίου' ($arF[$i]) contents error";
         }
      }
      else {
         $this->adeia_pratirio[] = '';
      }
       
      // 3: (4o πεδίο) Ημερομηνία και Ώρα FHM // YYYYMMDDhhmm
      if (strlen($ar1[3])!=12) {
         $this->errors[] = "Line $j: Field 'DateTime' length error";
      }
      else if ( ($this->is_s && substr($ar1[3],0,8) > ('20'.substr($this->fname,15,6))) || 
         (!$this->is_s && substr($ar1[3],0,8) > ('20'.substr($this->fname,11,6))) ) 
      {
         $this->errors[] = "Line $j: Field 'DateTime' ($ar1[3]) after from TXT filename";
      }
      else if (substr($ar1[3],8,2)>23 || substr($ar1[3],10,2)>59) {
         $this->errors[] = "Line $j: Field 'DateTime' ($ar1[3]) time error";
      }
      $this->fdatetime[] = $ar1[3];
      
      // 4: (5o πεδίο) A/A Ημερήσιων Σημάνσεων # πλήθος επιστροφών $ αξία επιστροφών
      $arF=$this->parse_daily_no($ar1[4]);
      // checks
      $i = cDAILYFHM::dailyno;
      if (!isset($arF[$i])) {
         $this->errors[] = "Line $j: Field 'Daily Count' ($ar1[4]) contents error";
      }
      else if (!preg_match('/^[0-9]{1,5}$/', $arF[$i]) || $arF[$i]<1 || $arF[$i]>9999) {
         $this->errors[] = "Line $j: Field 'Daily Count' ($arF[$i]) contents error";
      }
      else if ($this->is_s && $j>0 && !$this->is_temp) { // S
         $n=count($this->daily);
         $prev = $n==0 ? 0 : $this->daily[$n-1];
         if ($arF[$i]!=($prev+1)) {
            $this->errors[] = "Line $j: Field 'Daily Count' ($arF[$i]) error, incorrect sequence";
         }
      }
      $this->daily[] = $ar1[4]; // save the whole field

      $i = cDAILYFHM::retcount;
      if (isset($arF[$i])) {
         $this->retcount[] = $arF[$i];
      }
      else {
         $this->retcount[] = 0;
      }

      $i = cDAILYFHM::retvalue;
      if (isset($arF[$i])) {
         if (strlen($arF[$i])>13) {
            $this->errors[] = "Line $j: Field ".($i+1)." (".$arF[$i].") length error";
         }

         $ar2=explode('.', $arF[$i]);
         do {
            if (count($ar2)!=2) {
               $this->errors[] = "Line $j: Syntax error in field ".($i+1)." (".$arF[$i].")";
               break;
            }

            $s2=sprintf("%d.%02d", $ar2[0], $ar2[1]);
            if ($s2!==$arF[$i]) {
               $this->errors[] = "Line $j: Syntax error in field ".($i+1)." (".$arF[$i].")";
               break;
            }

         } while (false);

         $this->retvalue[] = $arF[$i];
      }
      else {
         $this->retvalue[] = 0.0;
      }

      // 5: A/A Προοδευτικών Σημάνσεων
      if (!preg_match('/^[0-9]{1,8}$/', $ar1[5])) {
         $this->errors[] = "Line $j: Field 'Progressive Count' ($ar1[5]) contents error";
      }
      else {
         $n=count($this->progressive);
         if ($n>0 && $ar1[5]!=($this->progressive[$n-1]+1)) {
            $this->errors[] = "Line $j: Field 'Progressive Count' ($ar1[5]) error, incorrect sequence";
         }
      }
      $this->progressive[] = $ar1[5];
      
      // 6: Αριθμός Ζ
      if (!preg_match('/^[0-9]{1,4}$/', $ar1[6])) {
         $this->errors[] = "Line $j: Field 'Z no.' ($ar1[6]) contents error";
      }
      else if ($this->is_s) { // S
         $z4 = (int)substr($this->fname,11,4); // FHM
         if ($ar1[6]!=$z4) { // FHM
            $this->errors[] = "Line $j: Field 'Z no.' ($ar1[6]) different from TXT filename ($z4)";
         }
      }
      else {
         if ($ar1[6]!=(int)substr($this->fname,17,4)) {
            $this->errors[] = "Line $j: Field 'Z no.' ($ar1[6]) different from TXT filename (".substr($this->fname,17,4).")";
         }
      }
      $this->eznr[] = $ar1[6];
      
      // 7-15: Διάφορες αξίες FHM
      for ($i=7;$i<=15;$i++) {
         if (strlen($ar1[$i])>13) {
            $this->errors[] = "Line $j: Field ".($i+1)." (".$ar1[$i].") length error";
         }
         
         $ar2=explode('.', $ar1[$i]);
         do {
            if (count($ar2)!=2) {
               $this->errors[] = "Line $j: Syntax error in field ".($i+1)." (".$ar1[$i].")";
               break;   
            }
            
            $s2=sprintf("%d.%02d", $ar2[0], $ar2[1]);
            if ($s2!==$ar1[$i]) {
               $this->errors[] = "Line $j: Syntax error in field ".($i+1)." (".$ar1[$i].")";
               break;
            }
            
         } while (false);      
      }
      $this->enetvala[] = $ar1[7];  
      $this->enetvalb[] = $ar1[8];
      $this->enetvalc[] = $ar1[9];
      $this->enetvald[] = $ar1[10];
      $this->enetvale[] = $ar1[11];
      $this->evatvala[] = $ar1[12];
      $this->evatvalb[] = $ar1[13];
      $this->evatvalc[] = $ar1[14];
      $this->evatvald[] = $ar1[15];
      
      // Κωδικός νομίσματος
      if ($ar1[16]!=="0" && $ar1[16]!=="EUR") {
         $this->errors[] = "Line $j: Field 'Currency code' ($ar1[16]) error";
      }
      $this->ecurcode[] = $ar1[16];
      
      // Signature
      $fsign=trim(array_pop($ar1));
      $s1=implode('', $ar1);
      $s2=sha1($s1);
      if (strcasecmp($s2, $fsign)!=0) {
         $this->errors[] = "Line $j: Signature error (should be ".strtoupper($s2)." instead of $fsign)";
      }
      $this->esign[] = $fsign;
   }
   
   function getSSignByData($oldsign)
   {
      $bytes=array();
      
      // Add old D sign, then calculate hash
      $this->esign[]=$oldsign;
      foreach($this->esign as $hex) {
         $l=strlen($hex);
         
         // take care for padding chars. if on last block after 'AES decrypt'
         if ($l>40 && ord($hex{40})<=16) {
            $l=40;
         }
         for ($i=0;$i<$l;$i+=2) {
            $s1=substr($hex,$i,2);
            sscanf($s1, "%X", $x);
            $bytes[]= $x;
         }
      }
      
      $iv = call_user_func_array("pack", array_merge(array("C*"), $bytes));
      
      return sha1($iv); 
   }
}
//--------------------------------------   
function uerror($umsg)
{
   echo "<div class=ERROR>".myhtml($umsg)."</div>";
}
//--------------------------------------
function GrNumber($x)
{
   return number_format($x, 2, ',', '.');
}
//--------------------------------------
function HexToBin($src) // deprecated, use native hex2bin() instead
{
   $bytes=array();
   $l=strlen($src);           
   for ($i=0;$i<$l;$i+=2) {    
      $s1=substr($src,$i,2);
      sscanf($s1, "%X", $x);
      $bytes[]= $x;
   }
   $bin = call_user_func_array("pack", array_merge(array("C*"), $bytes));
   return $bin;
}
//--------------------------------------
function ReadParams()     
{
   global $x2;            
   $db=&$x2->db;
   
   $query = "SELECT PNAME, PVALUE FROM reselprefex WHERE AGENTID=0 AND RESELID=0 AND PGROUP='Esend.params' 
      AND PNAME IN ('ACCEPT_D_SIGN_ERROR', 'DEFAULT_POSTINTERVAL')";
   if (($rs=$db->Execute($query))===false) {
      error_log( __FUNCTION__.' '.__LINE__.' '.$db->ErrorMsg() );
      return;
   }
   while ($o1=$rs->FetchNextObject()) { 
      if ($o1->PNAME==='ACCEPT_D_SIGN_ERROR')
         $x2->acceptDSignErr = (bool)(int)$o1->PVALUE;
      else if ($o1->PNAME==='DEFAULT_POSTINTERVAL')
         $x2->repeatPostAfter = (int)$o1->PVALUE;
   }
   $rs->Close();
}
//--------------------------------------
function process_s_file($charset, $ui, $encrypted)
/* normal = 928, false, true */
{
   global $x2;
   $db=&$x2->db;
   
   $maxz=0;
   $oldsign='';
   $ssign='';
   $debug_data = false;
      
   do {
      $cc = new cCHECKER($charset, $ui, true/* is_s*/);
      if ($cc->err!=0) {
         // some error occured
         $cc->text_log();
         //
         // Any error at this point will not be recorded
         //
         return $cc; 
      }
      
      $query="SELECT MAX(ZNR) FROM ese_z WHERE EAFDSS=:EAFDSS";
      $data=array('EAFDSS'=>$cc->eafdssEn8);
      if (($rs=$db->Execute($query,$data))===false) {
         $cc->errors[] = __LINE__.$db->ErrorMsg();
         $cc->setError(99); // internal server error
         break;
      }
      $row=$rs->FetchRow();
      if ($row!==false && $row[0]!==null) {
         $maxz=(int)$row[0]; // reset
      }
      $rs->Close();
      
      if ($cc->znr <= $maxz) {
         $cc->errors[] = "Το Z με α/α $cc->znr έχει ήδη υποβληθεί (το τελευταίο ήταν το $maxz)";
         $cc->param = $maxz;
         if (!$ui) {
            $cc->setError(3);
            break;
         }
      }
      
      if (!$cc->bypassZcheck) {
         if ($maxz>0 && $cc->znr > ($maxz+1) && ($cc->znr - $maxz)<100) {
            // do not accept
            $cc->errors[] = "Λείπει το προηγούμενο Z από το $cc->znr (το τελευταίο ήταν το $maxz)";
            $cc->param = $maxz;
            if (!$ui) {
               $cc->setError(4);
               break; // but it could continue
            }               
         }
      }
      
      if ($encrypted) {
         //
         // DECRYPT
         //
         if (!isset($_REQUEST['IV']) || strlen($_REQUEST['IV'])==0) {
            $_REQUEST['IV'] = str_repeat('00',16);
         }
         $iv=hex2bin($_REQUEST['IV']);

         $key=hex2bin($cc->aeskey);
         
         $text=file_get_contents($_FILES['S_TXT_FILE']['tmp_name']);
         if ($text===false) {
            $cc->errors[] = "Could not read uploaded file contents";
            $cc->setError(99); // internal server error
            break; // can not continue
         }
         
         $tlen = strlen($text);
         $t16 = $tlen % 16;
         if ($t16==2 && ord($text{$tlen-2})==0xD && ord($text{$tlen-1})==0xA) {
            $text = substr($text, 0, $tlen-2); // reset
         }
         
         $text2 = openssl_decrypt($text, 'AES-256-CBC', $key,  OPENSSL_RAW_DATA|OPENSSL_ZERO_PADDING, $iv);
         unset($text);
         if ($text2===false) {
            $cc->errors[] = "Could not decrypt uploaded file contents";
            $cc->setError(5); // decoding error
            break; // can not continue
         }
         
         /*
         CREATE TABLE ese_z_decoded (
            EAFDSS   NVARCHAR2(20),
            ZNR      INTEGER,
            STXT     CLOB,
            PRIMARY KEY (EAFDSS, ZNR)
            );
         */
         //$debug_data = $text2."\r\n";
         
         if ($ui) {
            pre(ToUtf8($text2));
         }
         
         $lines=explode("\n", $text2);
         unset($text2);
         
         $nLines=count($lines);
         while ($nLines>0 && strlen(trim($lines[$nLines-1]))<40) {
            array_pop($lines);
            $nLines--;
         }
      }
      else {
         // 
         // Read AS IS (not encrypted)
         //
         $lines=file($_FILES['S_TXT_FILE']['tmp_name']);
         if ($lines===false) {
            $cc->errors[] = "Could not read uploaded file contents";
            $cc->setError(99); // internal server error
            break; // can not continue
         }
         
         $nLines=count($lines);
         while ($nLines>0 && strlen(trim($lines[$nLines-1]))==0) {
            array_pop($lines);
            $nLines--;
         }
      }
      
      if ($nLines==0) {
         $cc->errors[] = "Λείπει η τελευταία γραμμή";
         $cc->setError(5); // possible encoding error
         break;
      }
      
      //
      // AFTER DECRYPTION: (do we need this?)
      //
      
      // Remove final empty line (if it exists)
      /*
      while ($nLines>0) {
         $line1 = trim($lines[$nLines-1]); // always 928
         if (strlen($line1)<=16) { // AES block size
            array_pop($lines);
            $nLines--;
         }
         else {
            break;
         }
      }
      */
      
      $ssign = trim($lines[$nLines-1]);
      $regex = '/^[0-9A-F]{40}.?$/i';  // strict
      if (!preg_match($regex, $ssign)) {
         // clear all other error and set this single one
         $cc->errors = array("Λάθος στην υποβληθείσα ΠΑΗΠΣ ($ssign). Πιθανό λάθος στο κλειδί AES");
         $cc->setError(5); // possible encoding error
         break; // can not continue
      }
      $ssign = substr($ssign, 0, 40); // reset (security)
      
      if ($ui) {
         echo "Πλήθος γραμμών = $nLines ΕΑΦΔΣΣ=$cc->eafdssEn8 Ζ=$cc->znr";
         show_file_excel($lines, $cc->mtype==0?23:18);
      }
      
      // Read previous Z (if any)
      if ($maxz>0) {
         if ($cc->znr>1) {
            $query="SELECT HEXSIGN FROM ese_z WHERE EAFDSS=:EAFDSS AND ZNR=:ZNR";
            $data=array('EAFDSS'=>$cc->eafdssEn8, 'ZNR' => $cc->znr - 1);
            if (($rs=$db->Execute($query,$data))===false) {
               $cc->errors[] = __LINE__.' DB error';
               $cc->setError(99); // internal server error
            }
            else {
               $row=$rs->FetchRow();
               $rs->Close();
               if ($row===false || $row[0]===null) {
                  $cc->errors[] = "Could not find record for Z=".($cc->znr - 1);
               }
               else {
                  $oldsign = $row[0];
               }
            }
         }
      }
      
      if ($ui && empty($oldsign))
      {
         $oldsign = $_REQUEST['PREV_D_SIGN'];
         umessage('Εγινε εφαρμογή της προηγούμενης υπογραφής D.TXT που έστειλε ο χρήστης');
      }
                  
      //
      // Parse once to get signature
      //
      $bindata = '';
      $brk=false;
      $regex = '/^[0-9A-F]{40}$/i';  // strict
      for ($i=0;$i<($nLines-1);$i++) {
         $ar1 = explode(';', $lines[$i]);
         if (empty($ar1)) {
            $cc->errors[] = 'Ελλιπής γραμμή '.($i+1);
            $cc->setError(5); // possible encoding error
            $brk=true;
            break;
         }
         
         if ($debug_data !== false)
         {
            $debug_data .= $lines[$i];
         }
         
         $esign = trim(array_pop($ar1));
         if (!preg_match($regex, $esign)) { 
            $cc->errors[] = 'Ελλιπής γραμμή '.($i+1);
            $cc->setError(5); // possible encoding error
            $brk=true;
            break;
         }
         
         $bindata .= hex2bin($esign);
      }
      if ($brk)
         break;
      
      if (!$cc->bypassZcheck && !empty($oldsign)) {
         $bindata .= hex2bin($oldsign);
         $s2 = sha1($bindata);
         if (strcasecmp($s2, $ssign)!=0) {
            $cc->errors[] = "Δεν συμφωνούν οι υπογραφές με το d.txt ή d.tmp (υπολογίσθηκε $s2)";
            if (!$x2->acceptDSignErr && !$ui) {          
               $cc->setError(6); 
               break;
            }
         }
         else if ($ui) {
            $cc->errors[] = 'ΟΙ ΥΠΟΓΡΑΦΕΣ ΣΥΜΦΩΝΟΥΝ';
         }
      }
      
      if ($ui) {
         // print errors so far, the clear
         if (!empty($cc->errors)) {
            echo '<div style="border:4px solid black">';
            $n=count($cc->errors);
            for ($i=0;$i<$n;$i++) {
               uerror($cc->errors[$i]);
            }
            echo '</div>';
            
            $cc->errors=array(); // reset
         }
      }
      
      //
      // Parse again to check lines
      //
      if ($debug_data !== false)
      {
         $debug_data .= "\r\nAfter check_line\r\n";
      }
      for ($i=0;$i<($nLines-1);$i++) {
         $cc->checkLine($i+1, $lines[$i]);
         if ($debug_data !== false)
         {
            $debug_data .= $lines[$i];
         }
      }
      
   } while (false);
   
   $zok=false;

   if ($cc->err==0 && !$ui) { // if $ui was set, it is only for test, so we dont write any file
      //
      // save data
      //
      $db->StartTrans();

      do {

         if ($cc->is_temp) 
         {
            // Write in all (new) records
            if (!update_ese_esi($cc))
               break;
               
            $dailystart = 0;
            $dailyend = 0;
            $n=count($cc->daily);
            for ($i=0;$i<$n;$i++) {
               if ($i==0 || $cc->daily[$i] < $dailystart) {
                  $dailystart = $cc->daily[$i];
               }
               
               if ($cc->daily[$i] > $dailyend) {
                  $dailyend = $cc->daily[$i]; 
               }
            }               
            $query="INSERT INTO ese_stmp (EAFDSS, ZNR, DAILYSTART, DAILYEND) VALUES(:EAFDSS, :ZNR, :DAILYSTART, :DAILYEND)";
            $data = array('EAFDSS'=>$cc->eafdssEn8, 'ZNR'=>(int)$cc->znr, 'DAILYSTART'=>$dailystart, 'DAILYEND'=>$dailyend);
            if (!$db->Execute($query,$data)) {
               $msg = "Could not save S.TMP info: ".$db->ErrorMsg();
               error_log($msg); 
               $cc->errors[] = "Could not save S.TMP info, DB error";   
               $cc->setError(99); // internal server error
               break;
            }
         }
         else // S.TXT
         {
            // Check existing and write in all (new) records
            if ($debug_data !== false)
            {
               $n=count($cc->daily);
               for ($i=0;$i<$n;$i++) {
                  $debug_data .= "\r\n".$cc->esign[$i];
               }
            }
            
            if (!update_ese_esi($cc))
               break;
               
            // Update ese_z
            $query="INSERT INTO ese_z (EAFDSS, ZNR, FNAMEDATE, HEXSIGN) 
               VALUES(:EAFDSS, :ZNR, TO_DATE(:FNAMEDATE, 'YYYYMMDDHH24MISS'), :HEXSIGN)";
            $sdate = '20'.substr($cc->fname, $cc->mtype==0?11:15, 10).'00'; 
            $data=array('EAFDSS'=>$cc->eafdssEn8, 'ZNR'=>(int)$cc->znr, 'FNAMEDATE'=>$sdate, 'HEXSIGN'=>$ssign);
            if (!$db->Execute($query,$data)) {
               error_log( __FUNCTION__.' '.__LINE__.' '.$db->ErrorMsg() );
               $cc->errors[] = "Could not save Z info: ".$db->ErrorMsg();  
               $cc->setError(99); // internal server error
               break;
            }
            
            $query = "DELETE FROM ese_stmp WHERE EAFDSS=:EAFDSS AND ZNR=:ZNR";
            $data = array('EAFDSS'=>$cc->eafdssEn8, 'ZNR'=>(int)$cc->znr);
            if (!$db->Execute($query,$data)) {
               error_log( __FUNCTION__.' '.__LINE__.' '.$db->ErrorMsg() );
               $cc->errors[] = "Could not clear S.TMP: ".$db->ErrorMsg();  
               $cc->setError(99); // internal server error
               break;
            }
            
            if ($debug_data !== false)
            {
               $query = 'INSERT INTO ese_z_decoded (EAFDSS, ZNR, STXT) VALUES(:EAFDSS, :ZNR, :STXT)';
               $data=array('EAFDSS'=>$cc->eafdssEn8, 'ZNR'=>$cc->znr, 'STXT'=>ToUTF8($debug_data));
               if (!$db->Execute($query,$data)) {
                  $cc->setError(99); // internal server error
                  error_log(__LINE__.' '.$db->ErrorMsg());
                  break;
               }
            }
            
            $zok=true; 
         }
         
      } while (false);

      $db->CompleteTrans();
   }
   
   //
   // Save in log
   //
   if (!$ui && !empty($_FILES['S_TXT_FILE']['name']) /* && !empty($_POST['IV'])*/ )
   {
      $sfn = $_FILES['S_TXT_FILE']['name'];
      $msg = strtr(implode("\n", $cc->errors), ':"', '  ');
      $data = array(
         'FNAME'      => gr_to_eng($charset==928 ? ToUTF8($sfn) : $sfn), 
         'REMOTEADDR' => @$_SERVER['REMOTE_ADDR'], 
         'RESULTCODE' => (int)$cc->err, 
         'MESSAGE'    => $msg
         );                                     
      if (!InsertEx($db,'ese_log',$data)) {
         error_log( __FUNCTION__.' '.__LINE__.' '.$db->ErrorMsg() );
         uerror('DB error');
      }
       
      if ($zok && !empty($msg)) {
         $query="UPDATE ese_z SET URESULT=:URESULT WHERE EAFDSS=:EAFDSS AND ZNR=:ZNR";
         $data=array('URESULT'=>1, 'EAFDSS'=>$cc->eafdssEn8, 'ZNR'=>$cc->znr);
         if (!$db->Execute($query,$data)) {
            error_log( __FUNCTION__.' '.__LINE__.' '.$db->ErrorMsg() );
            uerror('DB error');
         }
      }
   }   

   return $cc;
}
//--------------------------------------
function data_found($cc, $data, $existing, &$rseq1=false)
{
   global $x2;
   $db = &$x2->db;
   
   $daily = $data['DAILY'];
   update_data_log($cc->indatalog, 'Checking daily '.$daily);
   
   foreach ($existing as $o1)
   {
      if ($o1->DAILY == $daily)
      {
         if ($rseq1 !== false) {
            $rseq1 = $o1->RSEQ;
         }
            
         do {
            if (strcmp($data['ISSUER_AFM'], $o1->ISSUER_AFM) != 0) {
               update_data_log($cc->indatalog, 'Diff.ISSUER_AFM'); 
               break;
            }
                
            if (strcmp($data['RECV_AFM'], $o1->RECV_AFM) != 0) {
               update_data_log($cc->indatalog, 'Diff.RECV_AFM'); 
               break;
            }
             
            if (strcmp($data['EAFDSS'], $o1->EAFDSS) != 0) {
               update_data_log($cc->indatalog, 'Diff.EAFDSS');
               break;
            }
                
            if (strcmp($data['KARTAPOD'], $o1->KARTAPOD) != 0) {
               update_data_log($cc->indatalog, 'Diff.KARTAPOD');
               break;
            }
                
            if ($data['ZNR'] != $o1->ZNR) { // int
               update_data_log($cc->indatalog, 'Diff.ZNR');
               break;
            }
             
            if ($data['PROGRESSIVE'] != $o1->PROGRESSIVE) { // int
               update_data_log($cc->indatalog, 'Diff.PROGRESSIVE');
               break;
            }
                
            if ($data['DOCID'] != $o1->DOCID) { // int
               update_data_log($cc->indatalog, 'Diff.DOCID');
               break;
            }
               
            if (strcmp($data['SEIRA'], $o1->SEIRA) != 0) { // string
               update_data_log($cc->indatalog, 'Diff.SEIRA');
               break;
            }
                
            if ($data['DOCNR'] != $o1->DOCNR) { // int
               update_data_log($cc->indatalog, 'Diff.DOCNR');
               break;
            }
                
            if ($data['NETVALA'] != $o1->NETVALA) { // float
               update_data_log($cc->indatalog, 'Diff.NETVALA');
               break;
            }               
                
            if ($data['NETVALB'] != $o1->NETVALB) { // float
               update_data_log($cc->indatalog, 'Diff.NETVALB');
               break;
            }
                
            if ($data['NETVALC'] != $o1->NETVALC) { // float
               update_data_log($cc->indatalog, 'Diff.NETVALC');
               break;
            }
                
            if ($data['NETVALD'] != $o1->NETVALD) { // float
               update_data_log($cc->indatalog, 'Diff.NETVALD');
               break; 
            }
            
            if ($data['NETVALE'] != $o1->NETVALE) { // float
               update_data_log($cc->indatalog, 'Diff.NETVALE');
               break;
            }
                
            if ($data['VATVALA'] != $o1->VATVALA) { // float
               update_data_log($cc->indatalog, 'Diff.');
               break;
            }
                
            if ($data['VATVALB'] != $o1->VATVALB) { // float
               update_data_log($cc->indatalog, 'Diff.VATVALB');
               break;
            }
               
            if ($data['VATVALC'] != $o1->VATVALC) { // float
               update_data_log($cc->indatalog, 'Diff.VATVALC');
               break;
            }
               
            if ($data['VATVALD'] != $o1->VATVALD) { // float
               update_data_log($cc->indatalog, 'Diff.VATVALD');
               break;
            }
               
            if ($data['GTOTAL'] != $o1->GTOTAL) { // float
               update_data_log($cc->indatalog, 'Diff.GTOTAL');
               break;
            }
                
            if ($data['CURCODE'] != $o1->CURCODE) { // int
               update_data_log($cc->indatalog, 'Diff.CURCODE');
               break;
            }
               
            if (strcmp($data['FDATETIME'], $o1->FDATETIME) != 0) { // string
               update_data_log($cc->indatalog, 'Diff.FDATETIME');
               break;
            }
                
            if (strcmp($data['HEXSIGN'], $o1->HEXSIGN) != 0) { // string
               update_data_log($cc->indatalog, 'Diff.HEXSIGN');
               break;
            }
               
            if (strcmp($data['ARTHRO_FPA'], $o1->ARTHRO_FPA) != 0) { // string
               update_data_log($cc->indatalog, 'Diff.ARTHRO_FPA');
               break;
            }
               
            if ($data['PARAKRATISI_FOROU'] != $o1->PARAKRATISI_FOROU) { // float
               update_data_log($cc->indatalog, 'Diff.PARAKRATISI_FOROU');
               break;
            }
               
            if (strcmp($data['HMERA'], $o1->HMERA) != 0) { // string
               update_data_log($cc->indatalog, 'Diff.HMERA');
               break;
            }
               
            if ($data['KWD_FUEL'] != $o1->KWD_FUEL) { // int
               update_data_log($cc->indatalog, 'Diff.KWD_FUEL');
               break;
            }
               
            if ($data['LITRA_FUEL'] != $o1->LITRA_FUEL) { // float
               update_data_log($cc->indatalog, 'Diff.LITRA_FUEL');
               break;
            }
               
            if (strcmp($data['ADEIAPRAT'], $o1->ADEIAPRAT) != 0) { // string
               update_data_log($cc->indatalog, 'Diff.ADEIAPRAT');
               break;
            }
               
            if ($data['REL_DOCTYPE'] != $o1->REL_DOCTYPE) { // int
               update_data_log($cc->indatalog, 'Diff.');
               break;
            }
               
            if ($data['REL_DOCNR'] != $o1->REL_DOCNR) { // int
               update_data_log($cc->indatalog, 'Diff.REL_DOCNR');
               break;
            }
               
            if (strcmp($data['REL_SEIRA'], $o1->REL_SEIRA) != 0) { // string
               update_data_log($cc->indatalog, 'Diff.REL_SEIRA');
               break;
            }
               
            if (strcmp($data['REL_EAFDSS'], $o1->REL_EAFDSS) != 0) { // string
               update_data_log($cc->indatalog, 'Diff.REL_EAFDSS');
               break;
            }
               
            if ($data['REL_PROGRES'] != $o1->REL_PROGRES) { // int
               update_data_log($cc->indatalog, 'Diff.REL_PROGRES');
               break;
            }
               
            if (strcmp($data['E_EAFDSS'], $o1->E_EAFDSS) != 0) { // string
               update_data_log($cc->indatalog, 'Diff.E_EAFDSS');
               break;
            }
                
            if ($data['E_ZNR'] != $o1->E_ZNR) { // int
               update_data_log($cc->indatalog, 'Diff.E_ZNR');
               break;
            }
               
            if (strcmp($data['U_VATNO'], $o1->U_VATNO) != 0) { // string
               update_data_log($cc->indatalog, 'Diff.U_VATNO');
               break;
            }
               
            if ($data['RETCOUNT'] != $o1->RETCOUNT) { // int
               update_data_log($cc->indatalog, 'Diff.RETCOUNT');
               break;
            }
               
            if ($data['RETVALUE'] != $o1->RETVALUE) { // float
               update_data_log($cc->indatalog, 'Diff.RETVALUE');
               break;
            }
               
            update_data_log($cc->indatalog, 'Found a match, daily '.$daily.' rseq '.$o1->RSEQ );
            /*
            if ($rseq1 !== false) {
               $rseq1 = $o1->RSEQ;
            }
            */
            return true; // found a match
            
         } while (false);
      }
   }
   
   // not found so far
   //update_data_log($cc->indatalog, 'Not found daily '.$daily );
   return false; 
}
//--------------------------------------
function get_query($model)
{
   switch ($model)
   {
   case 'tmp':
      $t1 = 'ese_esi_tmp';
      break;
   case 'err':
      $t1 = 'ese_esi_err';
      break;
   default:
      $t1 = 'ese_esi';
      break;
   }
   
   $query = "INSERT INTO $t1 (ISSUER_AFM, RECV_AFM, EAFDSS, KARTAPOD, ZNR, DAILY, PROGRESSIVE, 
         DOCID, SEIRA, DOCNR, NETVALA, NETVALB, NETVALC, NETVALD, NETVALE, VATVALA, VATVALB, VATVALC, VATVALD,
         GTOTAL, CURCODE, FDATETIME, HEXSIGN, ARTHRO_FPA, PARAKRATISI_FOROU, HMERA, KWD_FUEL, LITRA_FUEL, 
         ADEIAPRAT, REL_DOCTYPE, REL_DOCNR, REL_SEIRA, REL_EAFDSS, REL_PROGRES,
         E_EAFDSS, E_ZNR, U_VATNO, RETCOUNT, RETVALUE";
   if ($model === 'tmp') { $query .= ", RSEQ"; }
   $query.= ")
         VALUES(:ISSUER_AFM, :RECV_AFM, :EAFDSS, :KARTAPOD, :ZNR, :DAILY, :PROGRESSIVE, 
         :DOCID, :SEIRA, :DOCNR, :NETVALA, :NETVALB, :NETVALC, :NETVALD, :NETVALE, :VATVALA, :VATVALB, :VATVALC, :VATVALD,
         :GTOTAL, :CURCODE, :FDATETIME, :HEXSIGN, :ARTHRO_FPA, :PARAKRATISI_FOROU, :HMERA, :KWD_FUEL, :LITRA_FUEL,
         :ADEIAPRAT, :REL_DOCTYPE, :REL_DOCNR, :REL_SEIRA, :REL_EAFDSS, :REL_PROGRES,
         :E_EAFDSS, :E_ZNR, :U_VATNO, :RETCOUNT, :RETVALUE";
   if ($model === 'tmp') { $query .= ", :RSEQ"; }
   $query .= ")";
   
   return $query;
}
//--------------------------------------
function SaveMaster($cc, $stmt, $o1)
{
   global $x2;
   $db=&$x2->db;
   
   /*
   $data2=array(
         'EAFDSS'       => $o1->EAFDSS,
         'ZNR'          => $o1->ZNR,
         'DAILY'        => $o1->DAILY,
         
         'ISSUER_AFM'   => $o1->ISSUER_AFM, 
         'RECV_AFM'     => $o1->RECV_AFM, 
         'KARTAPOD'     => $o1->KARTAPOD, 
         'PROGRESSIVE'  => $o1->PROGRESSIVE, 
         'DOCID'        => $o1->DOCID,
         'SEIRA'        => $o1->SEIRA, 
         'DOCNR'        => $o1->DOCNR, 
         'NETVALA'      => $o1->NETVALA, 
         'NETVALB'      => $o1->NETVALB, 
         'NETVALC'      => $o1->NETVALC, 
         'NETVALD'      => $o1->NETVALD, 
         'NETVALE'      => $o1->NETVALE, 
         'VATVALA'      => $o1->VATVALA, 
         'VATVALB'      => $o1->VATVALB,
         'VATVALC'      => $o1->VATVALC,
         'VATVALD'      => $o1->VATVALD,
         'GTOTAL'       => $o1->GTOTAL, 
         'CURCODE'      => $o1->CURCODE,
         'FDATETIME'    => $o1->FDATETIME, 
         'HEXSIGN'      => $o1->HEXSIGN,
         'ARTHRO_FPA'   => $o1->ARTHRO_FPA,
         'PARAKRATISI_FOROU' => $o1->PARAKRATISI_FOROU,
         'HMERA'        => $o1->HMERA,
         'KWD_FUEL'     => $o1->KWD_FUEL,
         'LITRA_FUEL'   => $o1->LITRA_FUEL,
         
         'ADEIAPRAT'    => $o1->ADEIAPRAT,
         'REL_DOCTYPE'  => $o1->REL_DOCTYPE,
         'REL_DOCNR'    => $o1->REL_DOCNR,
         'REL_SEIRA'    => $o1->REL_SEIRA,
         'REL_EAFDSS'   => $o1->REL_EAFDSS,
         'REL_PROGRES'  => $o1->REL_PROGRES,

         'E_EAFDSS'     => $o1->E_EAFDSS, 
         'E_ZNR'        => $o1->E_ZNR,
         'U_VATNO'      => $o1->U_VATNO,
         'RETCOUNT'     => $o1->RETCOUNT,
         'RETVALUE'     => $o1->RETVALUE
         );
   */
   $data2 = (array)$o1;
         
   update_data_log($cc->indatalog, print_r($data2, true) );

   return $db->Execute($stmt, $data2);
}   
//--------------------------------------
function update_ese_esi(&$cc)
{
   global $x2;
   $db=&$x2->db;
   
   $maxRseq = 0; // will only be used in TMP
   
   $msg = "EAFDSS=$cc->eafdssEn8 ZNR=$cc->znr";
   update_data_log($cc->indatalog, $msg);
   
   //
   // Get existing TMP collection
   //
   $existing = array();
   $query = "SELECT * FROM ese_esi_tmp WHERE EAFDSS=:EAFDSS AND ZNR=:ZNR ORDER BY RSEQ"; // Attention, daily may not be unique
   $data = array('EAFDSS'=>$cc->eafdssEn8, 'ZNR'=>$cc->znr);
   update_data_log($cc->indatalog, 'data='.print_r($data, true) );
   if (($rs=$db->Execute($query, $data))===false) {
      error_log( __FUNCTION__.' '.__LINE__.' '.$db->ErrorMsg() );
      $cc->errors[] = "Could not read daily info: ".$db->ErrorMsg();  
      $cc->setError(99); // internal server error
      return false;
   }
   while ($o1=$rs->FetchNextObject()) {
      $existing[] = $o1;
      if ($o1->RSEQ > $maxRseq) {
         $maxRseq = $o1->RSEQ;
      }
   }
   $rs->Close();
   //update_data_log($cc->indatalog, 'existing='.print_r($existing, true) ); o.k.
   
   //
   // Make inserts
   //
   $ok = true;
   $newdata = array();
   $newdaily = array();
   
   if ($cc->is_temp) {
      $queryTMP = get_query('tmp');
      $stmtTMP = $db->Prepare($queryTMP); 
   }
   else {
      $queryM = get_query('');
      $stmtM = $db->Prepare($queryM);
      
      $queryERR = get_query('err');
      $stmtERR = $db->Prepare($queryERR);
   }

   $tmpSame = array(); // RSEQ array
   $esi_errors = array(); // data arrays
   
   $n=count($cc->daily);
   for ($i=0;$i<$n;$i++) {
      $daily = (int)$cc->daily[$i];
      /*
      if (in_array($daily, $existing) || in_array($daily, $newdata))
         continue;
      */
         
      $data=array(
         'EAFDSS'       => $cc->eafdssEn8,
         'ZNR'          => (int)$cc->znr,
         'DAILY'        => $daily,
         
         'ISSUER_AFM'   => ToUTF8(substr($cc->eissuer_afm[$i],0, 20)), 
         'RECV_AFM'     => ToUTF8(substr(@$cc->erecv_afm[$i], 0, 20)), 
         'KARTAPOD'     => ToUTF8(substr($cc->ekartapod[$i], 0, 80)), 
         'PROGRESSIVE'  => (int)$cc->progressive[$i], 
         'DOCID'        => (int)@$cc->edocid[$i],
         'SEIRA'        => ToUTF8(@$cc->eseira[$i]), 
         'DOCNR'        => (int)@$cc->edocnr[$i], 
         'NETVALA'      => (float)$cc->enetvala[$i], 
         'NETVALB'      => (float)$cc->enetvalb[$i], 
         'NETVALC'      => (float)$cc->enetvalc[$i], 
         'NETVALD'      => (float)$cc->enetvald[$i], 
         'NETVALE'      => (float)$cc->enetvale[$i], 
         'VATVALA'      => (float)$cc->evatvala[$i], 
         'VATVALB'      => (float)$cc->evatvalb[$i],
         'VATVALC'      => (float)$cc->evatvalc[$i],
         'VATVALD'      => (float)$cc->evatvald[$i],
         'GTOTAL'       => (float)@$cc->egtotal[$i], 
         'CURCODE'      => (int)$cc->ecurcode[$i],
         'FDATETIME'    => ToUTF8(substr($cc->fdatetime[$i], 0, 12)), 
         'HEXSIGN'      => ToUTF8(substr($cc->esign[$i], 0, 40)),
         'ARTHRO_FPA'   => ToUTF8(substr(@$cc->earthro[$i], 0, 20)),
         'PARAKRATISI_FOROU' => (float)@$cc->eparakrat[$i],
         'HMERA'        => ToUTF8(substr($cc->Hmera[$i], 0, 10)),
         'KWD_FUEL'     => (int)@$cc->kwd_fuel[$i],
         'LITRA_FUEL'   => (float)@$cc->litra_fuel[$i],
         
         'ADEIAPRAT'    => ToUTF8(substr($cc->adeia_pratirio[$i], 0, 9)),
         'REL_DOCTYPE'  => (int)@$cc->rel_doc_type[$i],
         'REL_DOCNR'    => (int)@$cc->rel_doc_number[$i],
         'REL_SEIRA'    => ToUTF8(substr(@$cc->rel_doc_seira[$i], 0 , 10)),
         'REL_EAFDSS'   => ToUTF8(substr(@$cc->rel_s11[$i], 0, 11)),
         'REL_PROGRES'  => (int)@$cc->rel_progressive[$i],

         'E_EAFDSS'     => gr_to_eng(ToUTF8($cc->eeafdss11[$i])), 
         'E_ZNR'        => (int)$cc->eznr[$i],
         'U_VATNO'      => mb_substr((string)$cc->vatno, 0, 20), // $cc->vatno aready in UTF-8
         'RETCOUNT'     => (int)@$cc->retcount[$i],
         'RETVALUE'     => (float)@$cc->retvalue[$i],
         'RSEQ'         => ++$maxRseq // whether TMP or not
         /*
         'ISFINAL'      => ($cc->is_temp ? 0 : 1)
         */
         );
         
      $dataM = array_merge(array(), $data); // deep copy
         
      if ($cc->is_temp)
      {                  
         // Αν βρω ένα οποιοδήποτε ολόϊδιο, δεν το γράφω στην βάση, αλλιώς το γράφω
         if (data_found($cc, $data, $existing) || data_found($cc, $data, $newdata))
         { // if found identical
            update_data_log($cc->indatalog, 'SAME DAILY='.$daily );
            continue;
         }
         
         update_data_log($cc->indatalog, 'NOT Same Daily='.$daily );
         
         $newdata[] = (Object)$data;
         
         if (!$db->Execute($stmtTMP, $data)) {
            $cc->errors[] = "Could not save E (tmp) info: ".$db->ErrorMsg();
            $cc->setError(99); // internal server error
            $ok = false;
            break;
         }
      }
      else // S.TXT
      {
         $saveMaster = true;
         // Γράφω τα πάντα
         //
         // Αν βρω ένα οποιοδήποτε ολόϊδιο, το γράφω στην βάση και το σβήνω από TMP
         $rseq1 = 0;
         if (data_found($cc, $data, $existing, $rseq1))
         {
            update_data_log($cc->indatalog, "Identical RSEQ=$rseq1");
            $tmpSame[] = $rseq1; // identical, to be transfered (delete)
         }
         else if ($rseq1 != 0)
         {
            update_data_log($cc->indatalog, "RSEQ1=$rseq1");
            foreach ($existing as $o1)
            {
               if ($o1->RSEQ == $rseq1)
               {
                  update_data_log($cc->indatalog, "Found RSEQ match $rseq1");
                  // Γράφω το TMP record στο master αρχείο, και την τρέχουσα εγγραφή στο ERR
                  update_data_log($cc->indatalog, 'existing2='.print_r($existing, true) );
                  if (!SaveMaster($cc, $stmtM, $o1))
                  {
                     error_log( __FUNCTION__.' '.__LINE__.' '.$db->ErrorMsg() );
                     update_data_log($cc->indatalog,  "Could not save E (master) info: ".$db->ErrorMsg());
                     $cc->errors[] = "Could not save E (master) info: ".$db->ErrorMsg();
                     $cc->setError(99); // internal server error
                     $ok = false;
                  }
                  else if (!$db->Execute($stmtERR, $data)) 
                  {
                     error_log( __FUNCTION__.' '.__LINE__.' '.$db->ErrorMsg() );
                     update_data_log($cc->indatalog, "Could not save E (err) info: ".$db->ErrorMsg());
                     $cc->errors[] = "Could not save E (err) info: ".$db->ErrorMsg();
                     $cc->setError(99); // internal server error
                     $ok = false;
                  }
                  else // o.k.
                  {
                     $tmpSame[] = $rseq1; // to be deleted 
                     $saveMaster = false;
                     update_data_log($cc->indatalog, 'All done continue');
                  }
                  break;
               }
            }
         }
         else 
         {
            update_data_log($cc->indatalog, "RSEQ1=$rseq1");
         }

         // Αν βρω ένα οποιοδήποτε ίδιο DAILY (άσχετα αν είναι πανομοιότυπο), το 
         // μεταφέρω στα ERR, εκτός από το master file.         
         if (in_array($daily, $newdaily))
         {
            // should not happen, mark for error, too
            if (!$db->Execute($stmtERR, $data)) {
               error_log( __FUNCTION__.' '.__LINE__.' '.$db->ErrorMsg() );
               $cc->errors[] = "Could not save E (err) info: ".$db->ErrorMsg();
               $cc->setError(99); // internal server error
               $ok = false;
               break;
            }
         }
         else
         {
            $newdaily[] = $daily;
         }
         
         if ($saveMaster)
         {
            if (!$db->Execute($stmtM, $dataM)) {
               error_log( __FUNCTION__.' '.__LINE__.' '.$db->ErrorMsg() );
               $cc->errors[] = "Could not save E (master) info: ".$db->ErrorMsg();
               $cc->setError(99); // internal server error
               $ok = false;
               break;
            }
         }
      }
   }
   
   if ($ok) 
   {
      if (!empty($tmpSame)) 
      {
         $n = count($tmpSame);
         for ($i=0; $i<$n; $i+=1000)    
         {
            $t2 = array_slice($tmpSame, $i, 1000);
            $query = 'DELETE FROM ese_esi_tmp WHERE EAFDSS=:EAFDSS AND ZNR=:ZNR AND RSEQ IN ('.
               implode(',', $t2).')';
            $data = array('EAFDSS'=>$cc->eafdssEn8, 'ZNR'=>$cc->znr );
            update_data_log($cc->indatalog, $query);            
            if (!$db->Execute($query, $data)) {
               error_log( __FUNCTION__.' '.__LINE__.' '.$db->ErrorMsg() );
               $cc->errors[] = "Could not delete from TMP ";
               $cc->setError(99); // internal server error
               update_data_log($cc->indatalog, $db->ErrorMsg() );
               return false;
            }
         }
      }
      
      if (!$cc->is_temp) // S.TXT 
      {
         // move all data left in tmp, into err
         $query = 'INSERT INTO ese_esi_err 
            SELECT * FROM ese_esi_tmp WHERE EAFDSS=:EAFDSS AND ZNR=:ZNR';
         $data = array('EAFDSS'=>$cc->eafdssEn8, 'ZNR'=>$cc->znr );            
         if (!$db->Execute($query, $data)) {
            error_log( __FUNCTION__.' '.__LINE__.' '.$db->ErrorMsg() );
            $cc->errors[] = "Could not transfer TMP to ERR";
            $cc->setError(99); // internal server error
            return false;
         }
         
         $query = 'DELETE FROM ese_esi_tmp WHERE EAFDSS=:EAFDSS AND ZNR=:ZNR';
         $data = array('EAFDSS'=>$cc->eafdssEn8, 'ZNR'=>$cc->znr );            
         if (!$db->Execute($query, $data)) {
            error_log( __FUNCTION__.' '.__LINE__.' '.$db->ErrorMsg() );
            $cc->errors[] = "Could not delete from TMP";
            $cc->setError(99); // internal server error
            update_data_log($cc->indatalog, $query.' '.$db->ErrorMsg() );
            return false;
         }
      }
   }
   
   return $ok;
}         
//--------------------------------------
function libxml_display_error($error)
{
   $return = "<br/>\n";
   switch ($error->level) 
   {
   case LIBXML_ERR_WARNING:
      $return .= "<b>Warning $error->code</b>: ";
      break;
   case LIBXML_ERR_ERROR:
      $return .= "<b>Error $error->code</b>: ";
      break;
   case LIBXML_ERR_FATAL:
      $return .= "<b>Fatal Error $error->code</b>: ";
      break;
   }
   $return .= trim($error->message);
   if ($error->file) {
      $return .= " in <b>$error->file</b>";
   }
   $return .= " on line <b>$error->line</b>\n";

   return $return;
}
//--------------------------------------
function libxml_display_errors() 
{
   $errors = libxml_get_errors();
   foreach ($errors as $error) {
      print libxml_display_error($error);
   }
   libxml_clear_errors();
}
//--------------------------------------   
function set_status($pkgid, $id, $status)
{
   global $x2;
   $db=&$x2->db;
   
   $query="UPDATE ese_myfpkg SET MYFID=:MYFID, PROCSTATUS=:PROCSTATUS 
      WHERE PKGID=:PKGID AND (MYFID IS NULL OR MYFID = -1 OR MYFID=:MYFID)";   
   $data=array('MYFID'=>$id, 'PROCSTATUS'=>$status, 'PKGID'=>$pkgid); 
   $query2=embed_vars($query,$data);
   if (!$db->Execute($query2)) {
      echo __LINE__.$db->ErrorMsg()."\n";
   }
}
//--------------------------------------   
function insert_errmsg($pkgid, $msg)
{
   global $x2;
   $db=&$x2->db;
   static $stmINS=false;
   
   $maxEN=0;
   
   $query="SELECT MAX(ERRNO) FROM ese_myferr WHERE PKGID=$pkgid";
   if (($rs=$db->Execute($query))===false) {
      if ($db->ErrorNo()!=0) {
         echo __LINE__.$db->ErrorMsg()."\n";
         return;
      }
   }
   else {
      if ($row=$rs->FetchRow()) {
         $maxEN = $row[0];
      }
      $rs->Close();
   }
   
   $maxEN++;
   
   if ($stmINS===false) {
      $query="INSERT INTO ese_myferr (PKGID, ERRNO, ERRORDES) VALUES(:PKGID, :ERRNO, :ERRORDES)";
      $stmINS=$db->Prepare($query);
   }
   
   $data=array('PKGID'=>$pkgid, 'ERRNO'=>$maxEN, 'ERRORDES'=>$msg);
   if (!$db->Execute($stmINS,$data)) {
      echo __LINE__.$db->ErrorMsg()."\n";
   }
   
   /*
   $query="UPDATE ese_myfpkg SET MYFID = -1 WHERE PKGID=$pkgid AND MYFID IS NULL";
   if (!$db->Execute($query)) {
      echo __LINE__.$db->ErrorMsg()."\n";
   }
   */
}
//--------------------------------------   
function process_myf_ret($pkgid, $myfid, $rets)
{
   $packet = @simplexml_load_string($rets);
   if ($packet===false) {
      set_status($pkgid, -1, "XML out ERROR");
      insert_errmsg($pkgid, "ERROR: ".$rets);
      return;
   }

   if (!property_exists($packet, "id") || ($myfid!=0 && $packet->id!=$myfid)) {
      set_status($pkgid, -1, "XML out ERROR");
      insert_errmsg($pkgid, "ERROR: ".$rets);
      return;
   }
   
   if (!property_exists($packet, "status")) {
      set_status($pkgid, (int)$packet->id, "XML no status");
      insert_errmsg($pkgid, "ERROR: ".$rets);
      return;
   }
   
   if (!set_status($pkgid, (int)$packet->id, (string)$packet->status)) {
      return;
   }
   
   if (property_exists($packet, "errors") && is_object($packet->errors)) {
      if (property_exists($packet->errors, "error")) {
         if (count($packet->errors->error)>1) {
            foreach ($o1->errors->error as $err1) {
               insert_errmsg($pkgid, $err1);
            }
         }
         else {
            insert_errmsg($pkgid, $packet->errors->error);
         }
      }
   }
}
//--------------------------------------   
?>